// -*-c++-*-
/* $Id: $ */

/*
 *
 * Copyright (C) 2009 Antonio Nicolosi (nicolosi@cs.stevens.edu)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 */

/* 
 * Sources
 * 
 *   [list sources here]
 */

#include "mr_wrap.h"

void miracl_from_sfs (Big& B, bigint& b) {  
  b163_curve_s::mip ()->IOBASE=16;  

  B = Big (const_cast<char *>(b.cstr ()));
}

void sfs_from_miracl (bigint& b, Big& B) {
  static char buf[100];

  /* should first check that b would fit */
  b163_curve_s::mip ()->IOBASE=16;
  buf << B;

  b = bigint (buf);
}

void miracl_from_b163 (EC2& G, b163_point& Q) {
  Big x, y;
  b163_elem xx, yy;

  Q.affine_eq ();

  Q.clone_x (xx);
  Q.clone_y (yy);

  miracl_from_b163 (x, xx);    miracl_from_b163 (y, yy);
  G = EC2(x, y);
}

void miracl_from_b163 (Big& x, b163_elem& xx) {
  static char buf[43];

  b163_get_str (buf, xx);
  x = Big(buf);
}

void b163_from_miracl (b163_point& P, EC2& G) {
  b163_elem xx, yy;
  Big x, y;

  G.get(x, y);

  b163_from_miracl (xx, x);    b163_from_miracl (yy, y);
  P.set_to (xx, yy);
}

void b163_from_miracl (b163_elem& xx, Big& x) {
  static char buf[100];

  /* should first check that b would fir */
  b163_curve_s::mip ()->IOBASE=16;
  buf << x;

  b163_set_str (xx, buf);
}
