#include <click/config.h>
#include "icingcommon.hh"
#include "PocomonDeencapsulatorProcessor.hh"

CLICK_DECLS

PocomonDeencapsulatorProcessor::PocomonDeencapsulatorProcessor() 
{
    _errh = router()->chatter_channel("default");
}

PocomonDeencapsulatorProcessor::~PocomonDeencapsulatorProcessor()
{
}

void
PocomonDeencapsulatorProcessor::drop_it(Packet* p)
{
    if (noutputs() > 1)
	output(1).push(p);
    else
	p->kill();
}

Packet* 
PocomonDeencapsulatorProcessor::simple_action(Packet* p_in)
{
  const IcingHdr1* hdr1 = reinterpret_cast<const IcingHdr1*>(p_in->data());

  if(hdr1->icing_ver != ICING_CURRENT_VERSION)
    fatal << "version wrong!\n";

  uint32_t hdrlen = icing_hdrlen(hdr1);
  uint8_t nrealms = hdr1->path_len;
  uint8_t curr_idx = hdr1->path_idx;
  uint16_t total_len = icing_pktlen(hdr1);

  uint32_t recvsize = p_in->length();
  if(recvsize < hdrlen || curr_idx >= nrealms || total_len < hdrlen || recvsize < total_len)
    fatal << "Packet not well formed\n";



  hdrlen += 1; //for the length of return pocs
  

  p_in->pull(hdrlen); // Strip off the header, now we have a plain IP packet.
  return p_in;
}


ELEMENT_REQUIRES(icing)
EXPORT_ELEMENT(PocomonDeencapsulatorProcessor)
