#ifndef POCOMONDEENCAPSULATORPROCESSOR_HH_
#define POCOMONDEENCAPSULATORPROCESSOR_HH_

#include <click/element.hh>

#include <cstring>
#include <cstdio>
extern "C"
{
#include <arpa/inet.h>
}
#include "util.h"
#include "parseopt.h"
#include "icp_config.h"
#include "icinghdr.h"
#include "icingsec.h"

CLICK_DECLS

// What this element does:
// Takes an IP-in-ICING packet and strips out the ICING packet to leave just the innermost IP packet

class PocomonDeencapsulatorProcessor : public Element { public:
  
    PocomonDeencapsulatorProcessor();
    ~PocomonDeencapsulatorProcessor();		

    const char *port_count() const      { return PORTS_1_1X2;   }
    const char *class_name() const	{ return "PocomonDeencapsulatorProcessor"; }
    const char *processing() const	{ return PROCESSING_A_AH; }

    Packet* simple_action(Packet *);

private:

    void drop_it(Packet*);

    ErrorHandler* _errh;
    
};

CLICK_ENDDECLS
#endif
