#ifndef ICINGADREALMENTRY_HH_
#define ICINGADREALMENTRY_HH_

#include <click/element.hh>
CLICK_DECLS

class IcingConfig;
class RealmTable;

// "switches" the packet by setting the appropriate annotations so that
// the downstream elements can treat the packet properly. 
//
// Requires a 'CONFIG' element that points to a RealmTable
class AddRealmEntries : public Element { public:

    AddRealmEntries();
  
    const char *class_name() const	{ return "AddRealmEntries"; }
    const char *processing() const	{ return PROCESSING_A_AH; }
    const char *port_count() const      { return PORTS_1_1X2; }
    bool can_live_reconfigure() const   { return true; }

    Packet* simple_action(Packet *);

    int configure(Vector<String> &, ErrorHandler *);

 private:
    void error_packet(Packet* p);

    IcingConfig* _con;
    RealmTable* _realmtable;
    ErrorHandler* _errh;
};

CLICK_ENDDECLS
#endif
