#ifndef CHECKCURRENT_REALM_HH_
#define CHECKCURRENT_REALM_HH_

#include <click/element.hh>

CLICK_DECLS

class IcingConfig;

// checks that the realm referenced in the current path entry is our own realm.
class CheckCurrentRealm : public Element { public:
  
    CheckCurrentRealm();		
    ~CheckCurrentRealm();		

    const char *port_count() const      { return PORTS_1_1X2; }
    const char *class_name() const	{ return "CheckCurrentRealm"; }
    const char *processing() const	{ return PROCESSING_A_AH; }
    bool can_live_reconfigure() const   { return true; }

    Packet* simple_action(Packet *);

    int configure(Vector<String> &, ErrorHandler *);

private:

    void error_packet(Packet* p);

    IcingConfig* _con;
    ErrorHandler* _errh;
};

CLICK_ENDDECLS
#endif
