#include <click/config.h>
#include "icingcommon.hh"
#include "checkdestination.hh"

CLICK_DECLS

CheckDestination::CheckDestination() 
{
    _errh = router()->chatter_channel("default");
}

CheckDestination::~CheckDestination()
{
}

Packet* 
CheckDestination::simple_action(Packet* p)
{
    const IcingHdr1* ice_hdr = 
	reinterpret_cast<const IcingHdr1*>(p->data());

    uint8_t idx = ice_hdr->path_idx;
    uint8_t nrealms = ice_hdr->path_len;

    assert(idx < nrealms);

    if (++idx != nrealms) {

	if (noutputs() > 1) 
	    output(1).push(p);
	else 
	    p->kill();

        p = NULL;
    }

    return p;
}

CLICK_ENDDECLS
ELEMENT_REQUIRES(icing)
EXPORT_ELEMENT(CheckDestination)
