#ifndef CHECK_DESTINATION_HH_
#define CHECK_DESTINATION_HH_

#include <click/element.hh>
CLICK_DECLS

// checks whether packet is at its destination. Packet is emitted on
// output 0 if so and on output 1 if not or if another error happens.
// assumes that packet has passed through CheckCurrentRealm successfully
class CheckDestination : public Element { public:
  
    CheckDestination();		
    ~CheckDestination();		

    const char *port_count() const      { return "1/1-2";   }
    const char *class_name() const	{ return "CheckDestination"; }
    const char *processing() const	{ return "a/ah"; }
    bool can_live_reconfigure() const   { return true; }

    Packet* simple_action(Packet *);

private:

    ErrorHandler* _errh;
};

CLICK_ENDDECLS
#endif
