require(icing)

define($DAEMON_IP 0.0.0.0,
       $DAEMON_PORT 9070,
       $NEXTREALM  \< 00 A2 AB 16 9B 6F 4E 5B FC 93 03 4A F2 0D 7E D8 53 3B 03 3A > )

con::IcingConfig
  ( K	abcdefghijklmnop,
    OUR_REALMID \<  E9A3467B5326C91885265F1C36812184FA071932 \>,
	OUR_PRIV_K \< 04817E175CF74E6E78D6A12FFA5E29C0F0BE68EC25 \>,
    REALMTABLE rt,
    MODE Overlay)

elementclass Out {
    input 
    -> IcingPrint(PAYLOAD true)
    -> UDPIPEncap2($DAEMON_IP, $DAEMON_PORT, DST_ANNO, DST_PORT_ANNO)
    -> IPFragmenter(1500)   // other end needs IPReassembler()
//    -> Discard
    -> SimpleQueue() 
    -> RawSocket("UDP")
}

rt::RealmTable(con)
out::Out()

socket::Socket("UDP", $DAEMON_IP, $DAEMON_PORT)
    -> ic::IcingCheck()
    -> cc::CheckCurrentRealm(CONFIG con)
    -> cn::CheckNextHop(CONFIG con)
    -> vv::VtagVerify(CONFIG con)
    -> VtagProcess(CONFIG con)
    -> nr::NextRealm()
    -> irs::IcingRegularSwitch(CONFIG con)
    -> out

ic[1] -> Print('icing check failed') -> Discard
cc[1] -> Print('realm check failed') -> Discard
cn[1] -> Print('Unknown next hop') -> Discard
vv[1] -> Print('vtag verification failed') -> Discard
nr[1] -> Print('at final destination') -> Discard
irs[1] -> Print('No known neighbor') -> Discard

// format of neighbor string:
//      realmid is_neighbr linkaddr_a linkaddr_b
Script(write rt.add_realm $NEXTREALM phys_neigh 44.45.46.47 500)
