require(icing)

define($DAEMON_IP 0.0.0.0,
       $DAEMON_PORT 9070,
       $SOURCE_REALM \< E9A3467B5326C91885265F1C36812184FA071932 \>,
       $FORWARDER_REALM  \< 3ACAA261E5D83DBCC15694D3733B5FDD9745E202 \>,
       $NEXT_REALM0 \< DCB507F713E9CB734AD5813C5674A217DCF3127B \>,
       $NEXT_REALM1 \< 254F23337AC4B6422E39480D301A08726EE7752E \>,
       $NEXT_REALM2 \< F1C778C19477884261D0F23A037D0CBC215D836D \>,
       $NEXT_REALM3 \< A9BC23F474EA93B90748FECACFB4A60BC7BCC4BC \>,
       $NEXT_REALM4 \< C0A3ECACE6A18F78AF1C00EB03E5F5733FCAFA13 \>,
       $FORWARDER_K abcdefghijklmnop,
       $NEXT_K ponmlkjihgfedcba,
	   $SOURCE_PRIVK \< 04817E175CF74E6E78D6A12FFA5E29C0F0BE68EC25 \>,
	   $FORWARDER_PRIVK \< 064D8A0C9DE692D08BA0D10840846F2540B0D6BC0D \>,
	   $FORWARDER_G 1,
	   $FORWARDER_V 16,
	   $NEXT_G 1,
	   $NEXT_V 16
       )


dk::DeriveKey
	(
	 K $FORWARDER_K,
	);

con::IcingConfig
  ( 
//    DERIVEKEY dk,
    K $FORWARDER_K,
    OUR_REALMID   $FORWARDER_REALM,
	OUR_PRIV_K    $FORWARDER_PRIVK,
    REALMTABLE  rt,
    MODE Overlay)
   
rt::RealmTable(con)

IcingSource(SECRET1 $FORWARDER_K,
	    SECRET2 $NEXT_K,
	    REALM0 $SOURCE_REALM,
	    REALM1 $FORWARDER_REALM,
	    REALM2 $NEXT_REALM0,
		PRIVK  $SOURCE_PRIVK,
		G1 $FORWARDER_G,
		G2 $NEXT_G,
		V1 $FORWARDER_V,
		V2 $NEXT_V,
	    INTERVAL 10)
    -> ic::IcingCheck()
    -> cc::CheckCurrentRealm(CONFIG con)
    -> cn::CheckNextHop(CONFIG con)
    -> vv::VtagVerify(CONFIG con)
    -> afe::AddRealmEntries(CONFIG con)
    -> VtagProcess(CONFIG con)
    -> nr::NextRealm()
    -> irs::IcingRegularSwitch(CONFIG con)
    -> IcingPrint()
    -> out :: {input  
       -> UDPIPEncap2($DAEMON_IP, $DAEMON_PORT, DST_ANNO, DST_PORT_ANNO)
//     -> Discard
       -> SimpleQueue() 
       -> RawSocket("UDP") 
    }

ic[1] -> Print('icing check failed') -> Discard
cc[1] -> Print('realm check failed') -> Discard
cn[1] -> Print('unknown next hop') -> Discard
afe[1] -> Print('couldnt add realms; bad news bears') -> Discard
vv[1] -> Print('vtag verification failed') -> Discard
nr[1] -> Print('at final destination') -> Discard
irs[1] -> Print('unknown neighbor') -> Discard

// hard-coded dummy value
//XXX:
Script(write rt.add_realm $NEXT_REALM0 phys_neigh 44.45.46.47 500,
       write rt.add_realm $SOURCE_REALM non_neigh 1.2.3.4 500,
       write rt.add_realm $NEXT_REALM1 phys_neigh 78.78.78.79 600,
       write rt.add_realm $NEXT_REALM4 phys_neigh 78.78.78.79 600,
       write rt.add_realm $NEXT_REALM2 phys_neigh 78.78.78.79 600,
       write rt.remove_realm $NEXT_REALM1,
       read rt.dump)

