require(icing)

AnnotationInfo(DST_ETHER 17 6)
AnnotationInfo(CHECK_OVERLAP PAINT DST_ETHER)

define($CURRENT_REALM \< E9A3467B5326C91885265F1C36812184FA071932 \>,
	   $PRIVK \< 04817E175CF74E6E78D6A12FFA5E29C0F0BE68EC25 \>,
	   $K \< 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33 \>,

	   $REALM_0 \< F1C778C19477884261D0F23A037D0CBC215D836D \>,
	   $REALM_1 \< F1C778C19477884261D0F23A037D0CBC215D836D \>,
	   $REALM_2 \< F1C778C19477884261D0F23A037D0CBC215D836D \>,
	   $REALM_3 \< F1C778C19477884261D0F23A037D0CBC215D836D \>,

	   $ETH_0 00:00:ca:fe:00:00,
	   $ETH_1 00:00:ca:fe:00:01,
	   $ETH_2 00:00:ca:fe:00:02,
	   $ETH_3 00:00:ca:fe:00:03,
	   
	   $NETH_0 00:00:ca:fe:00:03,
	   $NETH_1 00:00:ca:fe:00:03,
	   $NETH_2 00:00:ca:fe:00:03,
	   $NETH_3 00:00:ca:fe:00:03,

	   $SRC_IP 172.27.74.134,
	   $DEST_IP 172.27.74.135,
	   $PORT 7662
       )

AddressInfo(
	eth_fake 00:00:00:00:00:00,
	nf2c0 $ETH_0,
	nf2c1 $ETH_1,
	nf2c2 $ETH_2,
	nf2c3 $ETH_3)

rt::RealmTable(con)
 
hi::HardwareInterface(con,
		  FIRST_IFACE nf2c0,
		  ETHADDR0 $ETH_0,
		  ETHADDR1 $ETH_1,
		  ETHADDR2 $ETH_2,
		  ETHADDR3 $ETH_3)

udp::Socket("udp", 0.0.0.0, $PORT)
udp2::Socket("udp", $DEST_IP, $PORT)
 
con::IcingConfig
  ( K  $K,
    OUR_REALMID $CURRENT_REALM,
	OUR_PRIV_K $PRIVK,
    REALMTABLE  rt,
    HWINTERFACE hi,
    MODE L3)
 
elementclass IO {

    elementclass Port {
	$devname |
	
	    FromDevice($devname) 
	    -> output

	    input 
	    -> Queue()  
	    -> ToDevice($devname)
    }


    port0::Port(nf2c0)
    port1::Port(nf2c1)
    port2::Port(nf2c2)
    port3::Port(nf2c3)

    port0 -> Paint(0) -> output
    port1 -> Paint(1) -> output
    port2 -> Paint(2) -> output
    port3 -> Paint(3) -> [1]output

    input -> ps::PaintSwitch
    ps[0] -> port0
    ps[1] -> port1
    ps[2] -> port2
    ps[3] -> port3

}

io::IO
    -> Strip(14) 
    -> IcingPrint()
    -> ic::IcingCheck()
    -> cc::CheckCurrentRealm(CONFIG con)
    -> cn::CheckNextHop(CONFIG con)
    -> ar::AddRealmEntries(CONFIG con)
    -> Unstrip(14)
    -> io

io[1]
	-> Strip(14)
//	-> UDPIPEncap($SRC_IP, $PORT, $DEST_IP, $PORT)
	-> Print('Sending to UDP')
	-> SimpleQueue()
	-> udp2

udp
//	-> Print(LENGTH 1024)
//	-> MarkIPHeader(0)
//	-> CheckUDPHeader()
//	-> StripIPHeader()
//	-> Strip(8)
	-> ic2::IcingCheck()
	-> vv::VtagVerify(CONFIG con)
	-> Print('Sending to nf2c0')
	-> EtherEncap(0x9090, eth_fake:eth, nf2c0:eth)
	-> Paint(0)
	-> io

ic[1] -> Print('icing check failed') -> Discard
cc[1] -> Print('realm check failed') -> Discard
cn[1] -> Print('unknown next hop') -> Discard
ar[1] -> Print('add realm entries') -> Discard
ic2[1] -> Print('icing check failed') -> Discard
vv[1] -> Print('vtags failed') -> Discard

// hard-coded dummy value
Script(write rt.add_realm $REALM_0 pci_neigh eth_fake:eth 3)
Script(write rt.remove_non_neigh)
ControlSocket("TCP", 4662)
