#ifndef ICINGCHECK_HH_
#define ICINGCHECK_HH_

#include <click/element.hh>
CLICK_DECLS

// checks the Icing header for well-formedness:
    //    checks packet length against length claimed in Hdr
    //    checks total realms against total header length
    //    checks current realm against total realms
    //    some other stuff
class IcingCheck : public Element { public:
  
    IcingCheck();		
    ~IcingCheck();		

    const char *port_count() const      { return PORTS_1_1X2;   }
    const char *class_name() const	{ return "IcingCheck"; }
    const char *processing() const	{ return PROCESSING_A_AH; }

    Packet* simple_action(Packet *);

private:

    ErrorHandler* _errh;
};

CLICK_ENDDECLS
#endif
