#ifndef ICINGDENCAP_HH
#define ICINGDENCAP_HH

#include <click/element.hh>
#include "icingcommon.hh"
#include "icingconfig.hh"
#include "translationtable.hh"

CLICK_DECLS
class IcingDencap : public Element
{
	public:
		IcingDencap() { _errh = router()->chatter_channel("default"); }
		~IcingDencap() { }
		const char *class_name() const { return "IcingDencap"; }
		const char *processing() const { return PROCESSING_A_AH; }
		const char *port_count() const { return PORTS_1_1X2; }

		int configure(Vector<String> &, ErrorHandler *);
		Packet *simple_action(Packet *);
	
	private:
		IcingConfig *_config;
		TranslationTable *_table;
		ErrorHandler *_errh;
		IPAddress _defaultAddress;

		void errorPacket(Packet *);
		void buildPacket(WritablePacket *, TranslationInfo *);
		TranslationInfo *infoFromPacket(Packet *);
};
CLICK_ENDDECLS
#endif /* ICINGENCAP_HH */
