#include <click/config.h>
#include "icingcommon.hh"
#include "nextrealm.hh"

CLICK_DECLS

NextRealm::NextRealm() 
{
    _errh = router()->chatter_channel("default");
}

NextRealm::~NextRealm()
{
}

void
NextRealm::drop_it(Packet* p)
{
    if (noutputs() > 1)
	output(1).push(p);
    else
	p->kill();
}

Packet* 
NextRealm::simple_action(Packet* p_in)
{
    const IcingHdr1* hdr_in = 
	reinterpret_cast<const IcingHdr1*>(p_in->data());

    uint8_t curr_idx = hdr_in->path_idx;
    uint8_t nrealms = hdr_in->path_len;

    assert(curr_idx < nrealms);

    ++curr_idx;

    if (curr_idx == nrealms) {
	drop_it(p_in);
	return NULL;
    }

    WritablePacket* p = p_in->uniqueify();
    IcingHdr1* hdr = reinterpret_cast<IcingHdr1*>(p->data());
    hdr->path_idx = curr_idx;

    return p;
}

CLICK_ENDDECLS
ELEMENT_REQUIRES(icing)
EXPORT_ELEMENT(NextRealm)
