#ifndef NEXTREALM_HH_
#define NEXTREALM_HH_

#include <click/element.hh>
CLICK_DECLS

// sets the packet to increment the current realm
// presumes that packet passed through CheckCurrentRealm successfully.
//    Packet is emitted on output 0 in the usual case.
//    Packet is emitted on output 1 if there is no next realm
//    (usually means that the current realm is the destination)
class NextRealm : public Element { public:
  
    NextRealm();		
    ~NextRealm();		

    const char *port_count() const      { return PORTS_1_1X2;   }
    const char *class_name() const	{ return "NextRealm"; }
    const char *processing() const	{ return PROCESSING_A_AH; }

    Packet* simple_action(Packet *);

private:

    void drop_it(Packet*);

    ErrorHandler* _errh;

};

CLICK_ENDDECLS
#endif
