require(icing)

AnnotationInfo(DST_ETHER 17 6)
AnnotationInfo(CHECK_OVERLAP PAINT DST_ETHER)

define(
       $SOURCE_REALM \< E9A3467B5326C91885265F1C36812184FA071932 \>,
       $FORWARDER_REALM  \< 3ACAA261E5D83DBCC15694D3733B5FDD9745E202 \>,
       $NEXT_REALM0 \< DCB507F713E9CB734AD5813C5674A217DCF3127B \>,
       $FORWARDER_K abcdefghijklmnop,
       $FORWARDER_PRIVK \< 064D8A0C9DE692D08BA0D10840846F2540B0D6BC0D \>,
       )

rt::RealmTable(con)
 
hi::HardwareInterface(con,
		  FIRST_IFACE nf2c0,
		  ETHADDR0 00:00:ca:fe:00:01,
		  ETHADDR1 00:00:ca:fe:00:02,
		  ETHADDR2 00:00:ca:fe:00:03,
		  ETHADDR3 00:00:ca:fe:00:04)
   
 
con::IcingConfig
  ( K  $FORWARDER_K,
    OUR_REALMID $FORWARDER_REALM,
    OUR_PRIV_K $FORWARDER_PRIVK,
    REALMTABLE  rt,
    HWINTERFACE hi,
    MODE L3)
 
elementclass IO {

    elementclass Port {
	$devname |
	
	    FromDevice($devname) 
	    -> output

	    input 
	    -> Queue()  
	    -> ToDevice($devname)
    }


    port0::Port(nf2c0)
    port1::Port(nf2c1)
    port2::Port(nf2c2)
    port3::Port(nf2c3)

    port0 -> Paint(0) -> output
    port1 -> Paint(1) -> output
    port2 -> Paint(2) -> output
    port3 -> Paint(3) -> output

    input -> ps::PaintSwitch
    ps[0] -> port0
    ps[1] -> port1
    ps[2] -> port2
    ps[3] -> port3

}

io::IO
    -> Strip(14) 
    -> ic::IcingCheck()
    -> cc::CheckCurrentRealm(CONFIG con)
    -> cn::CheckNextHop(CONFIG con)
    -> ar::AddRealmEntries(CONFIG con)
    -> IcingPrint()
    -> Unstrip(14)
    -> io

ic[1] -> Print('icing check failed') -> Discard
cc[1] -> Print('realm check failed') -> Discard
cn[1] -> Print('unknown next hop') -> Discard
ar[1] -> Print('add realm entries') -> Discard

// hard-coded dummy value
Script(write rt.add_realm $NEXT_REALM0 phys_neigh 00:0C:42:07:19:1A 2)
Script(write rt.add_realm $SOURCE_REALM phys_neigh 00:0C:42:07:19:18 0)
