#ifndef ICINGREGULARSWITCH_HH
#define ICINGREGULARSWITCH_HH

#include <click/element.hh>
CLICK_DECLS

class IcingConfig;
class RealmTable;

// "switches" the packet by setting the appropriate annotations so that
// the downstream elements can treat the packet properly. 
//
// Requires a 'CONFIG' element that in turn points to a RealmTable
class IcingRegularSwitch : public Element { public:

    IcingRegularSwitch();
  
    const char *class_name() const	{ return "IcingRegularSwitch"; }
    const char *processing() const	{ return PROCESSING_A_AH; }
    const char *port_count() const      { return "1/1-3"; }
    bool can_live_reconfigure() const   { return true; }

    Packet* simple_action(Packet *);

    int configure(Vector<String> &, ErrorHandler *);

 private:
    void error_packet(Packet* p);

    IcingConfig* _con;
    RealmTable* _realmtable;
    ErrorHandler* _errh;
};

CLICK_ENDDECLS
#endif
