#include <click/config.h>
#include "icingcommon.hh"
#include "vtagprocess.hh"
#include "icingconfig.hh"

CLICK_DECLS

VtagProcess::VtagProcess() 
{
    _errh = router()->chatter_channel("default");
}

VtagProcess::~VtagProcess()
{
}

Packet* 
VtagProcess::simple_action(Packet* p_in)
{
    WritablePacket* p = p_in->uniqueify();
    IcingHdr1* hdr = reinterpret_cast<IcingHdr1*>(p->data());
    advance_vtags(hdr, _con->privkey()); 
    return p;
}

int
VtagProcess::configure(Vector<String> &conf, ErrorHandler *errh)
{
    int before = errh->nerrors();

    Element* elem;

    if (cp_va_kparse(conf, this, errh,
		     "CONFIG", cpkP+cpkM, cpElement, &elem,
		     cpEnd) < 0)
	return -1;

    if ( (_con = static_cast<IcingConfig*>(elem->cast("IcingConfig"))) == NULL)
	errh->error("CONFIG needs to be an IcingConfig object");

    return (before == errh->nerrors() ? 0 : -1);
}

CLICK_ENDDECLS
ELEMENT_REQUIRES(icing)
EXPORT_ELEMENT(VtagProcess)
