#ifndef VTAGPROCESS_HH_
#define VTAGPROCESS_HH_

#include <click/element.hh>
CLICK_DECLS

class IcingConfig;

// sets the packet to process the vtag by wrapping it up
// in another layer of encryption.
// presumes that packet passed through CheckCurrentRealm successfully.
class VtagProcess : public Element { public:
  
    VtagProcess();		
    ~VtagProcess();		

    const char *port_count() const      { return PORTS_1_1X2;   }
    const char *class_name() const	{ return "VtagProcess"; }
    const char *processing() const	{ return PROCESSING_A_AH; }
    bool can_live_reconfigure() const   { return true; }

    Packet* simple_action(Packet *);

    int configure(Vector<String> &, ErrorHandler *);

private:

    IcingConfig* _con;
    ErrorHandler* _errh;
};

CLICK_ENDDECLS
#endif
