#ifndef VTAGVERIFY_HH_
#define VTAGVERIFY_HH_

#include <click/element.hh>

CLICK_DECLS

class IcingConfig;

// checks the vtag in the packet. assumes that IcingCheck was called
// first
class VtagVerify : public Element { public:
  
    VtagVerify();		
    ~VtagVerify();		

    const char *port_count() const      { return PORTS_1_1X2; }
    const char *class_name() const	{ return "VtagVerify"; }
    const char *processing() const	{ return PROCESSING_A_AH; }
    bool can_live_reconfigure() const   { return true; }

    Packet* simple_action(Packet *);

    int configure(Vector<String> &, ErrorHandler *);

private:

    void error_packet(Packet* p);

    IcingConfig* _con;
    ErrorHandler* _errh;
};

CLICK_ENDDECLS
#endif
