
# SFSLITE

AC_DEFUN([SFSLITE],
[AC_ARG_WITH(sfslite,
	[AS_HELP_STRING([--with-sfslite[[=PATH]]], [specify location of sfslite (default is /usr/local)])])
AC_ARG_WITH(sfsmode,
	[AS_HELP_STRING([--with-sfsmode[[=MODE]]], [set sfsmode (default is shared)])])

if test -z "$with_sfsmode" ; then
	with_sfsmode=shared
fi

if test "$with_sfslite" = yes -o "$with_sfslite" = "" ; then
	for dir in "$prefix" /usr/local /usr; do
		if test -L $dir/lib/sfslite; then
			with_sfslite=$dir
			break
		fi
	done
fi

case "$with_sfslite" in
	/*) ;;
	*) with_sfslite="$PWD/$with_sfslite" ;;
esac

sfslib=${with_sfslite}"/lib/sfslite/"${with_sfsmode}
sfsinc=${with_sfslite}"/include/sfslite/"${with_sfsmode}

if test ! -f ${sfslib}/libasync.la ; then
	AC_MSG_ERROR("Cannot find sfslite")
fi

AC_SUBST(sfslib)
AC_SUBST(sfsinc)

CPPFLAGS="$CPPFLAGS -I${sfsinc}"
LDFLAGS="$LDFLAGS -L${sfslib}"
])

# MIRACL
AC_DEFUN([MIRACL],
[AC_ARG_WITH(miracl,
  [AS_HELP_STRING([--with-miracl[[=PATH]]], [specify location of miracl])])
 
if test -n "$with_miracl" -a "$with_miracl" != yes ; then
	case "$with_miracl" in
		/*) ;;
		*) with_miracl="$PWD/$with_miracl" ;;
	esac

	if test -f "$with_miracl/libmiracl-b163.a" ; then
		LDFLAGS="$LDFLAGS -L${with_miracl}"
		LIBS="-lmiracl-b163"" $LIBS"
	else
		AC_MSG_ERROR("Cannot find miracl")
	fi
elif test "$with_miracl" = yes ; then
	AC_MSG_ERROR("miracl path not specified")
fi
])

# CHI
AC_DEFUN([CHI],
[
AC_ARG_WITH(chi,
	[AS_HELP_STRING([--with-chi[[=PATH]]], [specify location of libchi (default is /usr/local)])])
if test "$with_chi" = yes -o -z "$with_chi" ; then
	for dir in "$prefix" /usr/local /usr ; do
		if test -f $dir/lib/libchi.la ; then
			with_chi=$dir
			break
		fi
	done
fi

case "$with_chi" in
	/*) ;;
	*) with_chi="$PWD/$with_chi" ;;
esac

if test -f "$with_chi/lib/libchi.la" ; then
		LDFLAGS="$LDFLAGS -L$with_chi/lib"
		CPPFLAGS="$CPPFLAGS -I$with_chi/include"
else
	AC_MSG_ERROR("Cannot find libchi")
fi

])
