#ifndef ICINGCLIENT_H_
#define ICINGCLIENT_H_
#include "async.h"
#include "arpc.h"
#include "util.h"

struct IcingQuestion
{
	enum question_t { HOST, PS };

	question_t type;
	str query;
	ptr<aclnt> client;
};

class IcingClient
{
	public:
		str _server;
		uint16_t _port;

		void setup(callback<void>::ptr);
		void call(str);

		typedef callback<void, uint32_t>::ptr lookupcb;

	private:
		ptr<aclnt> _client;
		uint32_t _fd, _ttfd;
		ps_partialpath_vec _partialpaths;

		void call(IcingQuestion, lookupcb);
		void call(str, lookupcb);

		void connected(callback<void>::ptr, int);
		void connectedToGluePS(IcingQuestion, lookupcb, int);
		void getReply(ptr<ps_reply>,  IcingQuestion, lookupcb, clnt_stat);
		void handleReply(ptr<ps_reply>, IcingQuestion, lookupcb);

		void handlePaths(ptr<ps_reply>, lookupcb);
		void handlePS(ptr<ps_reply>, IcingQuestion, lookupcb);

		void addPaths(icp_path_vec);
		void addPartials(ps_partialpath_vec);
};

#endif /* ICINGCLIENT_H_ */
