#ifndef VERIFY_PATH_H_
#define VERIFY_PATH_H

#include "icp_types.h"

enum icp_cert_field_selector
{
	ICP_CERT_TO = 0,
	ICP_CERT_FROM = 1
};

typedef rpc_vec<const icp_memcert *, RPC_INFINITY> memcert_vec;
struct memcert_db_rec
{
	icp_pubkey realm;
	memcert_vec memcerts;

	ihash_entry<memcert_db_rec> hlink;
};
typedef ihash<icp_pubkey, memcert_db_rec, &memcert_db_rec::realm,
		&memcert_db_rec::hlink> memcert_db;

bool icp_cert_includes(const icp_certificate &, icp_cert_field_selector, const icp_realm &, 
		ptr<memcert_db>);
bool icp_verify_path(const icp_path &path);

#endif /* VERIFY_PATH_H_ */
