%#include "icp_types.h"
enum ps_reply_stat
{
	PS_SERVER_FOUND = 0,
    PS_PATH_FOUND = 1,
	PS_UNKNOWN_HOST  = 2,
	PS_INVALID_ARG = 3,
	PS_NO_PATH = 4,
	PS_UNKNOWN_DOMAIN = 5
};

struct ps_partialpath
{
	icp_pubkey realm;
    icp_path_vec paths;
};
typedef ps_partialpath ps_partialpath_vec<>;

struct ps_getargs
{
	icp_hostname host;
	ps_partialpath_vec partialpaths;
};

struct ps_nextps
{
    icp_hostname host;
    icp_path_vec paths;
};

union ps_reply switch(ps_reply_stat status)
{
    case PS_SERVER_FOUND:
		ps_nextps nextps;
    case PS_PATH_FOUND:
        icp_path_vec paths;
	default:
		void;
};

program ICING_PATHSERVER
{
	version PATHSERVER_VERS
	{
		ps_reply FIND_PATHTO_PS(ps_getargs) = 0;
		ps_reply FIND_PATHTO_HOST(ps_getargs) = 1;
	} = 1;
} = 1;
