typedef string icp_hostname<256>;
typedef opaque icp_pubkey[20];
typedef opaque icp_sig[42];
typedef opaque icp_poc[16];

enum icp_cert_type
{
	ICP_CERT_CLASSID = 0,
	ICP_CERT_PUBKEY = 1
};

struct icp_realm
{
	icp_pubkey pubkey;
	unsigned int vq;
};

union icp_cert_field switch(icp_cert_type type)
{
	case ICP_CERT_CLASSID:
		unsigned int id;
	case ICP_CERT_PUBKEY:
		icp_realm realm;
	default:
		void;
};

struct icp_certificate
{
	icp_realm realm;
	icp_realm prev;
	icp_realm next;

	unsigned int metric;
	unsigned hyper creation;
	unsigned hyper expiry;

	icp_sig sig;
};

struct icp_memcert 
{
	icp_pubkey realm;
	icp_pubkey member;

	unsigned int vq;
	unsigned int mask;
	
	unsigned hyper creation;
	unsigned hyper expiry;
	
	icp_sig sig;
};

struct icp_path
{
	icp_realm waypoints<>;
	icp_certificate certs<>;
	icp_memcert memcerts<>;
	icp_poc pocs<>;
};
typedef icp_path icp_path_vec<>;
