#include "async.h"
#include "ecdh.h"
#include <cstdio>

str k_str = "07A7C8D2863CF079840B02006C7CC8F21765A335DE";
str p_str = "F1086EEE876BF598EBC9F1DA3CB792119854B759";

int
main()
{
	// Simply convert from hex to data string
	char hex[3];
	hex[2] = '\0';
	rpc_bytes<> b;
	for(uint32_t i = 0; i < k_str.len() / 2; i++)
	{
		memcpy(hex, k_str.cstr() + (i*2), 2);
		long byte = strtol(hex, NULL, 16);
		b.push_back(byte & 0xFF);
	}

	str k(b.base(), b.size());
	
	//Turn string into a private key
	bigint x;
	x.setraw(k);
	ecdh_priv priv(x);

	// Attempt an ec_nidh with this private key
	uint8_t *buf = new uint8_t[16];
	ecdh_priv p2;
	ec_nidh(buf, 16, &p2, priv.public_key());

	// Convert from hex string to realmid
	rpc_bytes<> c;
	for(uint32_t i = 0; i < p_str.len() / 2; i++)
	{
		memcpy (hex, p_str.cstr() + (i*2), 2);
		long byte = strtol(hex, NULL, 16);
		c.push_back(byte & 0xFF);
	}

	// Convert from private key to chopped_raw
	chopped_ecpk_raw raw_from_priv;
	priv.to_chopped_ecpk_raw(raw_from_priv);

	//Convert from realmid to chopped_raw
	chopped_ecpk_raw raw_from_pubkey;
	memcpy(raw_from_pubkey, c.base(), sizeof(chopped_ecpk_raw));

	// Confirm that both chopped_raws are the same
	int i = memcmp(raw_from_pubkey, raw_from_priv, sizeof(chopped_ecpk_raw));
	if(i == 0)
		printf("generated pubkeys are the same");

	// Attempt to convert from chopped raw
	ecdh_pub pub1(raw_from_priv);
	ecdh_pub pub2(raw_from_pubkey);
}
