#include "util.h"
#include "pathserver.h"
class Test
{
	Pathserver ps;

	public:
	Test() : ps(1025)
	{}

	void
	run()
	{
		ps.init_from_file("test/server_init");
		ptr<icp_path> clpath = build_path_from_file("test/partial.path");

		icp_pubkey e;
		e = str("e");
		ps_partialpath_vec pvec;
		ps_partialpath partial;
		partial.realm = e;
		partial.paths.push_back(*clpath);
		pvec.push_back(partial);

		hostname_rec *rec = ps.hostdb[str("master.h.com")];
		ptr<icp_path_vec> newpaths = ps.get_paths(rec->realm, pvec);

		if(newpaths->size() == 1)
		{
			icp_path &newpath = (*newpaths)[0];
			for(uint32_t i = 0; i < newpath.waypoints.size(); i++)
				warn << newpath.waypoints[i].base() << ",";
			warn << "\n";
			for(uint32_t i = 0; i < newpath.certs.size(); i++)
				warn << newpath.certs[i].from.base() << ","
					<< newpath.certs[i].host.base() << ","
					<< newpath.certs[i].to.base() << "\n";

		}
	}
};

int main()
{
	Test test;
	test.run();
	return 0;
}
