#include "async.h"
#include "icinghdr.h"
#include "icingsec.h"
#include "converthex.h"

/*
 * Tests whether the PMAC of the path is the same as outputted by perl
 * *could* cause sender-not-authorized error
 */

/* Method:
 * parse realm ids into a Path object (with vnodes=0)
 * generate secret keys
 * PMAC the path (poc_from_path)
 */

str sourceStr= "e9a3467b5326c91885265f1c36812184fa071932";
str realmStr = "3acaa261e5d83dbcc15694d3733b5fdd9745e202";
str destStr = "dcb507f713e9cb734ad5813c5674a217dcf3127b";

str pocStr = "86a68619bc24c7793d53c3edbe155f3e";


void
parseRealms(RealmVoq *&voqs)
{
	bzero(voqs, 3 * sizeof(RealmVoq));
	convertFromHex((uint8_t *)sourceStr.cstr(), voqs[0].realmid.bytes, RealmIDWire::SIZE);
	convertFromHex((uint8_t *)realmStr.cstr(), voqs[1].realmid.bytes, RealmIDWire::SIZE);
	convertFromHex((uint8_t *)destStr.cstr(), voqs[2].realmid.bytes, RealmIDWire::SIZE);
}

int
main()
{
	RealmVoq *path;
	RealmSecret key;
	POC hwpoc, poc;

	path = new RealmVoq[3];
	bzero(&key, sizeof(RealmSecret));
	parseRealms(path);
	convertFromHex(pocStr, hwpoc);

	poc_from_path(poc, &key, (Path *)path, 3);
	if(memcmp(poc, hwpoc, sizeof(POC)) == 0)
	{
		printf("POCs match");
		return 0;
	}
	else
	{
		printf("POC mismatch\n");
		return 1;
	}
}
