#include "verify_path.h"

int main()
{
	icp_certificate cert;

	cert.to.set_type(ICP_CERT_CLASSID);
	cert.from.set_type(ICP_CERT_CLASSID);
	cert.realm = str("myrealm!");

	*cert.to.id = 0;

	icp_pubkey waypoint;
	waypoint = str("some waypoint");

	ptr<memcert_db> db = new refcounted<memcert_db>();

	bool test_zero = icp_cert_includes(cert, ICP_CERT_TO, waypoint, db);

	if(test_zero)
		warn << "Wee! Wildcard!\n";

	icp_memcert memcert;
	memcert.realm = str("myrealm!");
	memcert.member = waypoint;
	memcert.id = 23;

	*cert.from.id = 23;

	memcert_db_rec *rec = new memcert_db_rec();
	rec->realm = str("myrealm!");
	rec->memcerts.push_back(&memcert);
	db->insert(rec);

	bool test_23 = icp_cert_includes(cert, ICP_CERT_FROM, waypoint, db);
	if(test_23)
		warn << "Wee! 23!\n";
}
