require(icing)

AnnotationInfo(DST_ETHER 17 6)
AnnotationInfo(CHECK_OVERLAP PAINT DST_ETHER)

define(
  $CURRENT_REALM \< 254F23337AC4B6422E39480D301A08726EE7752E \>,
  $PRIVK \< 051A699CFF1E5A391E7D9A08DA37D95407E00AA4C5 \>,
  $K \< 36363636363636363636363636363636 \>,

	$REALM_0 \< DCB507F713E9CB734AD5813C5674A217DCF3127B \>,
	$REALM_1 \< F1C778C19477884261D0F23A037D0CBC215D836D \>,

	$NETH_0 00:4e:46:32:43:01,
	$NETH_1 00:22:19:d6:23:39,

  $ETH_0 00:4e:46:32:43:00,
	$ETH_1 00:4e:46:32:43:01,
	$ETH_2 00:4e:46:32:43:02,
	$ETH_3 00:4e:46:32:43:03
	
	)
	
hi::HardwareInterface(con,
		  FIRST_IFACE nf2c0,
		  ETHADDR0 $ETH_0,
		  ETHADDR1 $ETH_1,
		  ETHADDR2 $ETH_2,
		  ETHADDR3 $ETH_3)

rt::RealmTable(con)

elementclass IO {

    elementclass Port {
	$devname |
	
	    FromDevice($devname) 
	    -> Print("GOT")
	    -> output

	    input 
	    -> Queue()  
	    -> ToDevice($devname)
    }


    port0::Port(nf2c0)
    port1::Port(nf2c1)
    port2::Port(nf2c2)
    port3::Port(nf2c3)

    port0 -> Paint(0) -> output
    port1 -> Paint(1) -> output
    port2 -> Paint(2) -> output
    port3 -> Paint(3) -> [1]output

    input -> ps::PaintSwitch
    ps[0] -> port0
    ps[1] -> port1
    ps[2] -> port2
    ps[3] -> port3

}


con::IcingConfig
  ( K  $K,
    OUR_REALMID $CURRENT_REALM,
	OUR_PRIV_K $PRIVK,
    REALMTABLE  rt,
    HWINTERFACE hi,
    MODE L3)

io::IO
    -> Strip(14) 
    -> Print("HI")
    -> IcingPrint()
    -> ic::IcingCheck()
    -> cc::CheckCurrentRealm(CONFIG con)
    -> cn::CheckNextHop(CONFIG con)
    -> ar::AddRealmEntries(CONFIG con)
    -> Unstrip(14)
    -> io

io[1] -> Print('Dunno. Error?') -> Discard
ic[1] -> Print('icing check failed') -> Discard
cc[1] -> Print('realm check failed') -> Discard
cn[1] -> Print('unknown next hop') -> Discard
ar[1] -> Print('add realm entries') -> Discard


// hard-coded dummy value
Script(write rt.add_realm $REALM_0 phys_neigh $NETH_0 2)
Script(write rt.add_realm $REALM_1 phys_neigh $NETH_1 3)
ControlSocket("TCP", 4662)
