require(icing)

AnnotationInfo(DST_ETHER 17 6)
AnnotationInfo(CHECK_OVERLAP PAINT DST_ETHER)

define(
	$K \< 35353535353535353535353535353535 \>,
	$CURRENT_REALM \< DCB507F713E9CB734AD5813C5674A217DCF3127B \>,
	$PRIVK \< 07A3FBD20D21D4E2E14262C52E4BDE0B332A84CD33 \>,

	$REALM_0 \< 3ACAA261E5D83DBCC15694D3733B5FDD9745E202 \>,
	$REALM_1 \< 254F23337AC4B6422E39480D301A08726EE7752E \>,

	$SRC_IP 64.57.23.82,
	$DEST_IP 64.57.23.42,
	$PORT 7662,
	)

rt::RealmTable(con)
 
udpReceive::Socket("udp", 0.0.0.0, $PORT) //Receives packets from la
udpSend::Socket("udp", $DEST_IP, $PORT) //Sends packets to the next hop(houston)
 
con::IcingConfig
  ( K  $K,
    OUR_REALMID $CURRENT_REALM,
//May not need next two lines?
	OUR_PRIV_K $PRIVK,
    REALMTABLE  rt,
    MODE Overlay)


udpReceive
    -> Print('IO Recv')

/*  Don't need to de-encapsulate because icing does this for us.
    -> Strip(14) //Strip ethernet header
    -> StripIPHeader // Might be wise to condition on what IP is sending the request, but who cares for the demo?
    -> Strip(8) // Strip UDP header
*/
    -> IcingPrint()
    -> ic::IcingCheck()
    -> cc::CheckCurrentRealm(CONFIG con)
    -> cn::CheckNextHop(CONFIG con)
    -> ar::AddRealmEntries(CONFIG con)
    -> nr::NextRealm()
    -> IcingRegularSwitch(CONFIG con)
    -> UDPIPEncap2($SRC_IP, $PORT, DST_ANNO, DST_PORT_ANNO)
    -> IPFragmenter(1500)
    -> SimpleQueue()
    -> RawSocket("UDP")


ic[1] -> Print('icing check failed') -> Discard
cc[1] -> Print('realm check failed') -> Discard
cn[1] -> Print('unknown next hop') -> Discard
ar[1] -> Print('add realm entries') -> Discard
//ic2[1] -> Print('icing check failed') -> Discard
//vv[1] -> Print('vtags failed') -> IcingPrint() -> Discard

// hard-coded dummy value
Script(write rt.add_realm $REALM_0 pci_neigh 64.57.23.66 $PORT)
//Can be: non_neigh, phys_neigh, or pci_neigh... which one do we want here?
Script(write rt.add_realm $REALM_1 pci_neigh 64.57.23.42 $PORT)
ControlSocket("TCP", 4662)
