require(icing)

AnnotationInfo(DST_ETHER 17 6)
AnnotationInfo(CHECK_OVERLAP PAINT DST_ETHER)

define(
	$REALM_0 \< 3ACAA261E5D83DBCC15694D3733B5FDD9745E202 \>,
	$REALM_1 \< 254F23337AC4B6422E39480D301A08726EE7752E \>,

	$NETH_0  00:00:ca:fe:01:0b,
	$NETH_1  00:00:ca:fe:02:0d,

	$MAC_0   00:00:ca:fe:00:0c,
	$MAC_1   00:00:ca:fe:01:0c,
	$MAC_2   00:00:ca:fe:02:0c,
	$MAC_3   00:00:ca:fe:03:0c,

	$K \< 35353535353535353535353535353535 \>,
	$CURRENT_REALM \< DCB507F713E9CB734AD5813C5674A217DCF3127B \>,
	$PRIVK \< 07A3FBD20D21D4E2E14262C52E4BDE0B332A84CD33 \>,
	)

rt::RealmTable(con)
 
hi::HardwareInterface(con,
		  FIRST_IFACE nf2c0,
		  ETHADDR0 $MAC_0,
		  ETHADDR1 $MAC_1,
		  ETHADDR2 $MAC_2,
		  ETHADDR3 $MAC_3)
   
 
con::IcingConfig
  ( K  $K,
    OUR_REALMID $CURRENT_REALM,
	OUR_PRIV_K $PRIVK,
    REALMTABLE  rt,
    HWINTERFACE hi,
    MODE L3)
 
elementclass IO {

    elementclass Port {
	$devname |
	
	    FromDevice($devname) 
	    -> output

	    input 
	    -> Queue()  
	    -> ToDevice($devname)
    }


    port0::Port(nf2c0)
    port1::Port(nf2c1)
    port2::Port(nf2c2)
    port3::Port(nf2c3)

    port0 -> Paint(0) -> output
    port1 -> Paint(1) -> output
    port2 -> Paint(2) -> output
    port3 -> Paint(3) -> output

    input -> ps::PaintSwitch
    ps[0] -> port0
    ps[1] -> port1
    ps[2] -> port2
    ps[3] -> port3

}

io::IO
    -> Strip(14) 
    -> ic::IcingCheck()
    -> cc::CheckCurrentRealm(CONFIG con)
    -> cn::CheckNextHop(CONFIG con)
    -> ar::AddRealmEntries(CONFIG con)
    -> IcingPrint()
    -> Unstrip(14)
    -> io

ic[1] -> Print('icing check failed') -> Discard
cc[1] -> Print('realm check failed') -> Discard
cn[1] -> Print('unknown next hop') -> Discard
ar[1] -> Print('add realm entries') -> Discard

// hard-coded dummy value
Script(write rt.add_realm $REALM_0 phys_neigh $NETH_0 1)
Script(write rt.add_realm $REALM_1 phys_neigh $NETH_1 2)

ControlSocket("tcp", 4662);
