require(icing)

AnnotationInfo(DST_ETHER 17 6)
AnnotationInfo(CHECK_OVERLAP PAINT DST_ETHER)

define($REALM_0 \< AA 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19  \>,
       $REALM_1 \< 33 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19  \>,
       $REALM_2 \< 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  \>,
       $REALM_3 \< 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  \>,
       $NETH_0  00:00:ca:fe:00:aa,
       $NETH_1  00:00:ca:fe:02:33,
       $NETH_2  00:00:ca:fe:03:00,
       $NETH_3  00:00:ca:fe:00:bb,
	   $MAC_0   00:00:ca:fe:00:32,
	   $MAC_1   00:00:ca:fe:01:32,
	   $MAC_2   00:00:ca:fe:02:32,
	   $MAC_3   00:00:ca:fe:03:32,
	   $K \< 32 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15  \>,
	   $CURRENT_REALM \< 5A 5A 5C 5C 25 D1 75 57 92 01 C2 9D 24 74 97 B7 C5 BC D8 19 \>,
	   $PRIVK \< 04 3B D5 D1 D1 59 61 0F 56 9D 12 2F ED B6 C0 AE F4 56 E3 BB AF \>)

rt::RealmTable(con)
 
hi::HardwareInterface(con,
		  FIRST_IFACE nf2c0,
		  ETHADDR0 $MAC_0,
		  ETHADDR1 $MAC_1,
		  ETHADDR2 $MAC_2,
		  ETHADDR3 $MAC_3)
   
 
con::IcingConfig
  ( K  $K,
    OUR_REALMID $CURRENT_REALM,
	OUR_PRIV_K $PRIVK,
    REALMTABLE  rt,
    HWINTERFACE hi,
    MODE L3)
 
elementclass IO {

    elementclass Port {
	$devname |
	
	    FromDevice($devname) 
	    -> output

	    input 
	    -> Queue()  
	    -> ToDevice($devname)
    }


    port0::Port(nf2c0)
    port1::Port(nf2c1)
    port2::Port(nf2c2)
    port3::Port(nf2c3)

    port0 -> Paint(0) -> output
    port1 -> Paint(1) -> output
    port2 -> Paint(2) -> output
    port3 -> Paint(3) -> output

    input -> ps::PaintSwitch
    ps[0] -> port0
    ps[1] -> port1
    ps[2] -> port2
    ps[3] -> port3

}

io::IO
    -> Strip(14) 
    -> ic::IcingCheck()
    -> cc::CheckCurrentRealm(CONFIG con)
    -> cn::CheckNextHop(CONFIG con)
    -> ar::AddRealmEntries(CONFIG con)
    -> IcingPrint()
    -> Unstrip(14)
    -> io

ic[1] -> Print('icing check failed') -> Discard
cc[1] -> Print('realm check failed') -> Discard
cn[1] -> Print('unknown next hop') -> Discard
ar[1] -> Print('add realm entries') -> Discard

// hard-coded dummy value
Script(write rt.add_realm $REALM_0 y $NETH_0 0)
Script(write rt.add_realm $REALM_1 y $NETH_1 1)
Script(write rt.add_realm $REALM_2 y $NETH_2 2)
Script(write rt.add_realm $REALM_3 y $NETH_3 3)

