require(icing)

AnnotationInfo(DST_ETHER 17 6)
AnnotationInfo(CHECK_OVERLAP PAINT DST_ETHER)

define($REALM_0 \< BB 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19  \>,
       $REALM_1 \< 36 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19  \>,
       $REALM_2 \< 34 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19  \>,
       $REALM_3 \< 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00  \>,
       $NETH_0  00:00:ca:fe:00:aa,
       $NETH_1  00:00:ca:fe:02:36,
       $NETH_2  00:00:ca:fe:01:34,
       $NETH_3  00:00:ca:fe:00:bb,
	   $MAC_0   00:00:ca:fe:00:35,
	   $MAC_1   00:00:ca:fe:01:35,
	   $MAC_2   00:00:ca:fe:02:35,
	   $MAC_3   00:00:ca:fe:03:35,
	   $K \< 35 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15  \>,
	   $CURRENT_REALM \< 35 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19  \>)

rt::RealmTable(con)
 
hi::HardwareInterface(con,
		  FIRST_IFACE nf2c0,
		  ETHADDR0 $MAC_0,
		  ETHADDR1 $MAC_1,
		  ETHADDR2 $MAC_2,
		  ETHADDR3 $MAC_3)
   
 
con::IcingConfig
  ( K  $K,
    OUR_REALMID $CURRENT_REALM,
    REALMTABLE  rt,
    HWINTERFACE hi,
    MODE L3)
 
elementclass IO {

    elementclass Port {
	$devname |
	
	    FromDevice($devname) 
	    -> output

	    input 
	    -> Queue()  
	    -> ToDevice($devname)
    }


    port0::Port(nf2c0)
    port1::Port(nf2c1)
    port2::Port(nf2c2)
    port3::Port(nf2c3)

    port0 -> Paint(0) -> output
    port1 -> Paint(1) -> output
    port2 -> Paint(2) -> output
    port3 -> Paint(3) -> output

    input -> ps::PaintSwitch
    ps[0] -> port0
    ps[1] -> port1
    ps[2] -> port2
    ps[3] -> port3

}

io::IO
    -> Strip(14) 
    -> ic::IcingCheck()
    -> cc::CheckCurrentRealm(CONFIG con)
    -> cn::CheckNextHop(CONFIG con)
    -> ar::AddRealmEntries(CONFIG con)
    -> IcingPrint()
    -> Unstrip(14)
    -> io

ic[1] -> Print('icing check failed') -> Discard
cc[1] -> Print('realm check failed') -> Discard
cn[1] -> Print('unknown next hop') -> Discard
ar[1] -> Print('add realm entries') -> Discard

// hard-coded dummy value
Script(write rt.add_realm $REALM_0 y $NETH_0 0)
Script(write rt.add_realm $REALM_1 y $NETH_1 1)
Script(write rt.add_realm $REALM_2 y $NETH_2 2)
Script(write rt.add_realm $REALM_3 y $NETH_3 3)

