#!/usr/bin/perl -w
# Generates paths from a list of waypoint voqs (one per line)
use strict;
use Getopt::Long;

my $templatefile;
my $pathfile;

GetOptions(
		"template=s" => \$templatefile,
		"pathfile=s" => \$pathfile);

die "too few options\n" unless $templatefile && $pathfile;
open TEMPLATE, "$templatefile" || die "Could not open template";
open PATHFILE, ">$pathfile" || die "Could not open pathfile";

my @realms;

while(my $str = <TEMPLATE>)
{
	chomp $str;
	my @realm;
	$str =~ m/(\S+)\s+(\S+)/;
	$realm[0] = $1;
	$realm[1] = $2;
	push @realms,\@realm;
}

foreach my $realm (@realms)
{
	print PATHFILE "waypoint @$realm[0] @$realm[1]\n";
}

my @cert;
my $first = 1;
foreach my $realm (@realms)
{
	push @cert,$realm;
	next if(scalar(@cert) < 3);

	{
		print PATHFILE "cert -1 0 $cert[1][0] $cert[1][1] $cert[2][0] $cert[2][1]\n";
		print PATHFILE "cert $cert[2][0] $cert[2][1] $cert[1][0] $cert[1][1] -1 0\n";
		print PATHFILE "memcert $cert[1][0] $cert[0][0] $cert[1][1] 32\n";
	}
	shift @cert
}
