require(icing)

AnnotationInfo(DST_ETHER 17 6)
AnnotationInfo(CHECK_OVERLAP PAINT DST_ETHER)

define(
	$CURRENT_REALM \< 3ACAA261E5D83DBCC15694D3733B5FDD9745E202 \>,
	$PRIVK \< 064D8A0C9DE692D08BA0D10840846F2540B0D6BC0D \>,
	$K \< 34343434343434343434343434343434 \>,

	$REALM_0 \< E9A3467B5326C91885265F1C36812184FA071932 \>,
	$REALM_1 \< DCB507F713E9CB734AD5813C5674A217DCF3127B \>,

	$NETH_1 00:00:ca:fe:01:0c,

	$ETH_0 00:00:ca:fe:00:0b,
	$ETH_1 00:00:ca:fe:01:0b,
	$ETH_2 00:00:ca:fe:02:0b,
	$ETH_3 00:00:ca:fe:03:0b,

	$SRC_IP 64.57.23.66,
	$DEST_IP 171.64.74.50,
	$PORT 7662
	)

AddressInfo(
	eth_fake 00:00:00:00:00:00,
	nf2c0 $ETH_0,
	nf2c1 $ETH_1,
	nf2c2 $ETH_2,
	nf2c3 $ETH_3)

rt::RealmTable(con)
 
hi::HardwareInterface(con,
		  FIRST_IFACE nf2c0,
		  ETHADDR0 $ETH_0,
		  ETHADDR1 $ETH_1,
		  ETHADDR2 $ETH_2,
		  ETHADDR3 $ETH_3)

udp::Socket("udp", 0.0.0.0, $PORT)
udp2::Socket("udp", $DEST_IP, $PORT)
 
con::IcingConfig
  ( K  $K,
    OUR_REALMID $CURRENT_REALM,
	OUR_PRIV_K $PRIVK,
    REALMTABLE  rt,
    HWINTERFACE hi,
    MODE L3)
 
elementclass IO {

    elementclass Port {
	$devname |
	
	    FromDevice($devname) 
	    -> output

	    input 
	    -> Queue()  
	    -> ToDevice($devname)
    }


    port0::Port(nf2c0)
    port1::Port(nf2c1)
    port2::Port(nf2c2)
    port3::Port(nf2c3)

    port0 -> Paint(0) -> output
    port1 -> Paint(1) -> output
    port2 -> Paint(2) -> output
    port3 -> Paint(3) -> [1]output

    input -> ps::PaintSwitch
    ps[0] -> port0
    ps[1] -> port1
    ps[2] -> port2
    ps[3] -> port3

}

io::IO
    -> Strip(14) 
    -> IcingPrint()
    -> ic::IcingCheck()
    -> cc::CheckCurrentRealm(CONFIG con)
    -> cn::CheckNextHop(CONFIG con)
    -> ar::AddRealmEntries(CONFIG con)
    -> Unstrip(14)
    -> io

io[1]
	-> Strip(14)
//	-> UDPIPEncap($SRC_IP, $PORT, $DEST_IP, $PORT)
	-> Print('Sending to UDP')
	-> SimpleQueue()
	-> udp2

udp
//	-> MarkIPHeader(0)
//	-> CheckUDPHeader()
//	-> StripIPHeader()
////	-> Strip(8)
//	-> SetTimestamp()
//	-> Print(TIMESTAMP true)
//	-> ic2::IcingCheck()
//	-> vv::VtagVerify(CONFIG con)
//	-> Print('Sending to nf2c0')
	-> EtherEncap(0x9090, eth_fake:eth, nf2c0:eth)
	-> Paint(0)
	-> io

ic[1] -> Print('icing check failed') -> Discard
cc[1] -> Print('realm check failed') -> Discard
cn[1] -> Print('unknown next hop') -> Discard
ar[1] -> Print('add realm entries') -> Discard
//ic2[1] -> Print('icing check failed') -> Discard
//vv[1] -> Print('vtags failed') -> IcingPrint() -> Discard

// hard-coded dummy value
Script(write rt.add_realm $REALM_0 pci_neigh eth_fake:eth 3)
Script(write rt.add_realm $REALM_1 phys_neigh $NETH_1 1)
ControlSocket("TCP", 4662)
