clear all;
close all;

printwidth = 330;
printheight = 150;

PATHLEN_COL = 1;
THR_COL = 2;

% get throughput from latency
importfile('pkt_create_raw.csv');
pktcreate = [data(:, PATHLEN_COL) data(:, THR_COL)];

% get throughput from latency
importfile('pkt_verify_raw.csv');
pktverify = [data(:, PATHLEN_COL) data(:, THR_COL)];

pktcreate = get_stats(pktcreate)
pktverify = get_stats(pktverify)

% EQ_c = polyfit(pktcreate(:,PATHLEN_COL), pktcreate(:,2), 1)
% TREND_c = EQ_c(1).* pktcreate(:,PATHLEN_COL) + EQ_c(2);
EQ_v = polyfit(pktverify(:,PATHLEN_COL), pktverify(:,2), 1)
TREND_v = EQ_v(1).* pktverify(:,PATHLEN_COL) + EQ_v(2);

H=figure('Position',[1 1 printwidth printheight]);
set(gcf,'PaperPositionMode','auto')
s = errorbar(pktcreate(:,PATHLEN_COL), pktcreate(:,2), pktcreate(:,3),'xk')
hold all;
% plot(pktcreate(:,PATHLEN_COL), TREND_c, '--k')
set(gca, 'FontName', 'times new roman');
r = errorbar(pktverify(:,PATHLEN_COL), pktverify(:,2), pktverify(:,3),'ok')
plot(pktverify(:,PATHLEN_COL), TREND_v, '--k')

xlabel('Path length');
ylabel('Latency (\mus)');
v=[0 40 0 800];
axis(v);
legend('Sender', 'Receiver', 'Location', 'n', 'Orientation', 'horizontal');
% legend boxoff
saveas(H, '../../../../doc/sosp09/figs/endhostvspathlen.eps');
hold off;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

importfile('poc_create_raw.csv');
poccreate = get_stats([data(:, PATHLEN_COL) 1e6./data(:, THR_COL)])
EQ = polyfit(poccreate(:,PATHLEN_COL), poccreate(:,2), 1)
TREND = EQ(1).* poccreate(:,PATHLEN_COL) + EQ(2);

H=figure('Position',[1 1 printwidth printheight]);
set(gcf,'PaperPositionMode','auto')
errorbar(poccreate(:,PATHLEN_COL), poccreate(:,2), poccreate(:,3), 'ok')
hold on
p = plot(poccreate(:,PATHLEN_COL), TREND, '--k')
%plot(poccreate(:,PATHLEN_COL), poccreate(:,2), 'xk', ...
%    poccreate(:,PATHLEN_COL), TREND, '--k')
set(gca, 'FontName', 'times new roman');
xlabel('Path length');
ylabel('Latency (\mus)');
legend('Avg','Trend', 'Location', 'NW');
legend boxoff;
%v=[0 40 0 350000];
%axis(v);
saveas(H, '../../../../doc/sosp09/figs/createpocsvspathlen.eps');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

importfile('build_path.throughput.dat');
buildpath = data

H=figure('Position',[1 1 printwidth printheight]);
set(gcf,'PaperPositionMode','auto')
errorbar(buildpath(:,PATHLEN_COL), buildpath(:,2), buildpath(:,3), 'xk')
set(gca, 'FontName', 'times new roman');
xlabel('No. of server paths');
ylabel('Throughput (paths/s)');
%v=[0 21 0 10000];
%axis(v);
saveas(H, '../../../../doc/sosp09/figs/buildpathvspathlen.eps');
