close all;
clear all;

printwidth = 330;
printheight = 150;

% IP ping RTTs max/avg/min/mdev
links = [51.650 51.701 51.759 0.247;...
         92.341 92.393 92.459 0.188;...
         0.004 0.006 0.017 0.002;...
         11.113 11.533 12.184 0.204;...
         4.719 4.804 4.887 0.089];

% wan 1st packet latency
importfile('wan.2009.3.6_22.43.52.latency.dat');
first_pkt = data/1000

% wan 2nd pkt latency
importfile wan.2009.3.6_22.43.52_noclear.latency.dat;
second_pkt = data/1000

% calculate data
links = sum(links)
stacks = [first_pkt(1,1) links(2) first_pkt(2,1)-links(2);...
          0              links(2) second_pkt(2,1)-links(2)]

x = ['First Pkt|Subsequent Pkts'];

figure1=figure('Position',[1 1 printwidth printheight]);
set(gcf,'PaperPositionMode','auto')
set(gca, 'FontName', 'times new roman');

bar(stacks, 0.4, 'stack');

colormap('copper');
ylabel('Latency (ms)');
set(gca,'XTickLabel', x)

% Create textarrow
annotation(figure1,'textarrow',[0.4939 0.4182],[0.4334 0.1334],...
    'TextEdgeColor','none',...
    'String',{'Control','Plane','Latency'});

% Create textbox
annotation(figure1,'textbox',[0.6271 0.4266 0.2091 0.2933],...
    'String',{'Rojak','Latency'},...
    'FitBoxToText','off',...
    'LineStyle','none');

% Create textbox
annotation(figure1,'textbox',[0.6319 0.1467 0.2091 0.2933],...
    'String',{'Link','Latency'},...
    'FitBoxToText','off',...
    'LineStyle','none');

% Create textbox
annotation(figure1,'textbox',[0.2483 0.16 0.2091 0.2933],...
    'String',{'Link','Latency'},...
    'FitBoxToText','off',...
    'LineStyle','none');

% Create textbox
annotation(figure1,'textbox',[0.2464 0.4667 0.2091 0.2933],...
    'String',{'Rojak','Latency'},...
    'FitBoxToText','off',...
    'LineStyle','none');

% legend('Control Path Latency', 'Link Delay', 'Rojak delay', 'Location', 'eo');
% legend boxoff
saveas(figure1, '../../../../doc/sosp09/figs/e2elatency.eps');
