#!/usr/bin/perl

use List::Util qw(sum);

foreach(@ARGV)
{
	my @lines = `cat $_`;
	my %values = ();
	my $file = "$_.summary";

	system("echo '' > $file");
	foreach(@lines)
	{
		chomp $_;

		unless(/#/ or $_ eq "")
		{
			my ($len, $val) = split(/, /, $_);
			if(not $len eq "")
			{
				$values{$len} = [] unless exists $values{$len};
				push @{$values{$len}}, $val;
			}
		}
	}

	system("echo '#PathLen\tMean\tStdDev' > $file");
	my @keys = sort {$a <=> $b} keys %values;

	foreach(@keys)
	{
		my @list = @{$values{$_}};
		my $len = scalar(@list);
		my $mean = sum(@list) / $len;
		my @deviations = map { ($_ - $mean) ** 2 } @list;
		my $stdev = 0;
		$stdev = sqrt( sum(@deviations) / (scalar(@deviations) - 1.0) )
			unless scalar(@deviations) == 1;

		system("echo '$_\t$mean\t$stdev' >> $file");
	}
}
