#!/usr/bin/perl

use List::Util qw(sum);

my $first = $ARGV[0];
#my $second = $ARGV[1];

my @firstLines = `cat $first`;
#my @secondLines = `cat $second`;

my $mean, $sdev;
my $out = "#1_ctrl\t 1_ping\t2_ctrl\t2_ping\n";

foreach(@ARGV)
{
	my @lines = `cat $_`;

	for (0, 1)
	{
		($mean, $sdev) = getStats(\@lines, $_);
		$out = $out . "$mean\t";
		print "$sdev\t";
	}
}
print "\n$out\n";

sub getStats
{
	my $lines = shift;
	my $column = shift;
	my @vals = ();

	foreach (@$lines)
	{
		chomp $_;
		unless(/#/ or $_ eq "")
		{
			my @cols = split(/, /, $_);
			push @vals, $cols[$column];
		}
	}

	my $mean = sum(@vals) / scalar(@vals);
	my @dev = map { ($_ - $mean) ** 2 } @vals;
	my $sdev = sqrt( sum(@dev) / (scalar(@dev) - 1.0)) unless scalar(@dev) == 1;

	return $mean, $sdev;
}
