#include <ecdh.h>
#include "../tt.h"
#include <cstdio>


int main()
{
	FILE *out = fopen("results.dat", "w+");
	uint8_t buf[16];
	time_it t;
	ecdh_priv priv, b;
	ecdh_pub pub = *b.public_key();

	tt count;
	for(int i = 0 ; i < 500; i++)
	{
		uint64_t before = get_now();
		t.begin();
		if(! ec_nidh(buf, 16, &priv, &pub))
		{
			printf("ERROR!");
			exit(1);
		}
		t.end();
		count.inc();
		uint64_t after = get_now();
		fprintf(out, "%lld\n", after - before);
		printf("%lld\n", after - before);
	}
	double num = count.num_per_sec();
	fprintf(out, "AVG: %f\nIN: %f\n", t.avg_us(), t.min_us());
	fprintf(out, "THROUGH: %f\n", num);
	printf("THROUGH: %f\n", num);
	fclose(out);
}
