#include <stdio.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>

#define PORT 9990
#define NUM_MESSAGES 1e10 // 1e7 == 10 million

void ERROR(char *str){
  printf("%s\n",str);
  exit(-1);
}

int main(int argc, char *argv[]){
  setbuf(stdout, NULL);
  int sock;
  struct sockaddr_in client;

  if(argc != 1){
    printf("Got %d args\n",argc);
    ERROR("Usage: receive [no arguments]");
  }

  if((sock= socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0){
    ERROR("Couldn't create socket");
  }

  memset(&client, 0, sizeof(client));
  client.sin_family = AF_INET;
  client.sin_addr.s_addr = htonl(INADDR_ANY);
  client.sin_port = htons(PORT);

  if( bind(sock, (struct sockaddr *) &client, sizeof(client)) < 0)
    ERROR("Couldn't bind socket");

  char buf[sizeof(uint32_t)];
  
  for(uint32_t i=0; i<NUM_MESSAGES; i++){
    const void *msg = buf;
    const int len = sizeof(buf);
    const int flags = 0;

    socklen_t clientSize = sizeof(client);
    if( recvfrom(sock, buf, len, flags, (struct sockaddr *) &client, &clientSize) < 0 ){
      ERROR("Size didn't match");
    }
    if( *((uint32_t *)buf) != i)
      printf("Got packet with value %d, expected %d\n", *((uint32_t *)buf), i);
    ERROR("Invalid packet recieved");
  }
}
