#include <errno.h>
#include <stdio.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>

#define PORT 9990
#define NUM_MESSAGES 1e10 // 1e7 == 10 million

void ERROR(char *str){
  printf("%s\n",str);
  exit(-1);
}


int main(int argc, char *argv[]){
  int sock;
  in_addr_t destIP;
  struct sockaddr_in server;

  if(argc != 2)
    ERROR("Usage: send <dest IP addr>");

  if((destIP = inet_addr(argv[1])) == (in_addr_t)(-1))
    ERROR("Couldn't parse IP addr");

  if((sock= socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0){
    ERROR("Couldn't create socket");
  }

  memset(&server, 0, sizeof(server));
  server.sin_family = AF_INET;
  server.sin_addr.s_addr = destIP;
  server.sin_port = htons(PORT);

  for(uint32_t i=0; i<NUM_MESSAGES; i++){
    const void *msg = &i;
    const int len = sizeof(i);
    const int flags = 0;
    if( sendto(sock, msg, len, flags, (struct sockaddr *) &server, sizeof(server)) != len){
      printf("Errno: %s\ne",strerror(errno));
      ERROR("Size didn't match");
    }
  }
}
