/*********** THESE ARE ALL WORD ADDRESSES (note the <<2 when printing external addresses) ***********/

// Crypto module block address
`define CRYPTO_REG_ADDR_WIDTH           `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
`define CRYPTO_BLOCK_ADDR_WIDTH         `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
`define CRYPTO_BLOCK_ADDR               `CRYPTO_BLOCK_ADDR_WIDTH'h9
`define CRYPTO_BLOCK_TAG                ({`UDP_BLOCK_SIZE_64_TAG, `CRYPTO_BLOCK_ADDR})


/*******************************************************************
 -- Internal addresses -- these are used inside the modules
 *******************************************************************/

// Crypto addresses
`define CRYPTO_KEY               	`CRYPTO_REG_ADDR_WIDTH'h0


/************************
  --- External addresses
 ************************/

`define CRYPTO_KEY_REG                      (`UDP_BASE_ADDRESS | {`CRYPTO_BLOCK_TAG, `CRYPTO_KEY})


/************************
  --- Print the registers
 ************************/
`define PRINT_USER_REG_ADDRESSES                                                                                                                   \
    $fwrite(c_reg_defines_fd, "#define CRYPTO_KEY_REG                          0x%07x\n\n", `CRYPTO_KEY_REG<<2)
