/* Register macros */
`define LOOKUP_REG_ADDR_WIDTH              `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
`define LOOKUP_BLOCK_ADDR_WIDTH            `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
`define LOOKUP_BLOCK_ADDR                  `LOOKUP_BLOCK_ADDR_WIDTH'h8
`define LOOKUP_BLOCK_TAG                   ({`UDP_BLOCK_SIZE_64_TAG, `LOOKUP_BLOCK_ADDR})

`define WILDCARD_LOOKUP_REG_ADDR_WIDTH     `UDP_BLOCK_SIZE_64k_REG_ADDR_WIDTH
`define WILDCARD_LOOKUP_BLOCK_ADDR_WIDTH   `UDP_BLOCK_SIZE_64k_BLOCK_ADDR_WIDTH
`define WILDCARD_LOOKUP_BLOCK_ADDR         `WILDCARD_LOOKUP_BLOCK_ADDR_WIDTH'h3
`define WILDCARD_LOOKUP_BLOCK_TAG          ({`UDP_BLOCK_SIZE_64k_TAG, `WILDCARD_LOOKUP_BLOCK_ADDR})

`define LOOKUP_WILDCARD_MISSES      `LOOKUP_REG_ADDR_WIDTH'h0
`define LOOKUP_WILDCARD_HITS        `LOOKUP_REG_ADDR_WIDTH'h1
`define LOOKUP_TOTAL_NUM_PKTS       `LOOKUP_REG_ADDR_WIDTH'h2
`define LOOKUP_TIMER                `LOOKUP_REG_ADDR_WIDTH'h3

`define WILDCARD_TABLE_SIZE            `WILDCARD_LOOKUP_REG_ADDR_WIDTH'd32

`define WILDCARD_LOOKUP_BASE           `WILDCARD_LOOKUP_REG_ADDR_WIDTH'h0
`define WILDCARD_ACTION_BASE           `WILDCARD_LOOKUP_REG_ADDR_WIDTH'h4000

`define WILDCARD_LOOKUP_PKTS_HIT_SKIP         36
`define WILDCARD_LOOKUP_BYTES_HIT_SKIP        37
`define WILDCARD_LOOKUP_LAST_SEEN_TS_SKIP     38
                                                    
`define WILDCARD_LOOKUP_BASE_REG           (`UDP_BASE_ADDRESS | {`WILDCARD_LOOKUP_BLOCK_TAG, `WILDCARD_LOOKUP_BASE})
`define WILDCARD_ACTION_BASE_REG           (`UDP_BASE_ADDRESS | {`WILDCARD_LOOKUP_BLOCK_TAG, `WILDCARD_ACTION_BASE})

`define LOOKUP_WILDCARD_MISSES_REG            (`UDP_BASE_ADDRESS | {`LOOKUP_BLOCK_TAG, `LOOKUP_WILDCARD_MISSES})
`define LOOKUP_WILDCARD_HITS_REG              (`UDP_BASE_ADDRESS | {`LOOKUP_BLOCK_TAG, `LOOKUP_WILDCARD_HITS})
`define LOOKUP_TOTAL_NUM_PKTS_REG             (`UDP_BASE_ADDRESS | {`LOOKUP_BLOCK_TAG, `LOOKUP_TOTAL_NUM_PKTS})
`define LOOKUP_TIMER_REG                      (`UDP_BASE_ADDRESS | {`LOOKUP_BLOCK_TAG, `LOOKUP_TIMER})

`define PRINT_USER_REG_ADDRESSES                                                                                                 \
  $fwrite(c_reg_defines_fd, "#define WILDCARD_TABLE_SIZE                   %07d\n", `WILDCARD_TABLE_SIZE);                       \
                                                                                                                                 \
  $fwrite(c_reg_defines_fd, "#define LOOKUP_WILDCARD_MISSES_REG            0x%07x\n", `LOOKUP_WILDCARD_MISSES_REG<<2);           \
  $fwrite(c_reg_defines_fd, "#define LOOKUP_WILDCARD_HITS_REG              0x%07x\n", `LOOKUP_WILDCARD_HITS_REG<<2);             \
  $fwrite(c_reg_defines_fd, "#define LOOKUP_TOTAL_NUM_PKTS_REG             0x%07x\n", `LOOKUP_TOTAL_NUM_PKTS_REG<<2);            \
  $fwrite(c_reg_defines_fd, "#define LOOKUP_TIMER_REG                      0x%07x\n\n", `LOOKUP_TIMER_REG<<2);                   \
                                                                                                                                 \
  $fwrite(c_reg_defines_fd, "#define WILDCARD_LOOKUP_BASE_REG              0x%07x\n", `WILDCARD_LOOKUP_BASE_REG<<2);             \
  $fwrite(c_reg_defines_fd, "#define WILDCARD_ACTION_BASE_REG              0x%07x\n", `WILDCARD_ACTION_BASE_REG<<2);             \
  $fwrite(c_reg_defines_fd, "#define WILDCARD_LOOKUP_PKTS_HIT_SKIP         0x%07x\n", `WILDCARD_LOOKUP_PKTS_HIT_SKIP<<2);        \
  $fwrite(c_reg_defines_fd, "#define WILDCARD_LOOKUP_BYTES_HIT_SKIP        0x%07x\n", `WILDCARD_LOOKUP_BYTES_HIT_SKIP<<2);       \
  $fwrite(c_reg_defines_fd, "#define WILDCARD_LOOKUP_LAST_SEEN_TS_SKIP     0x%07x\n\n", `WILDCARD_LOOKUP_LAST_SEEN_TS_SKIP<<2)
