/* Other Constants */
`define ICING_ETHTYPE 16'h9090
`define ICING_CURR_VER 1
`define ICING_MAX_PATH_LEN 8'd36

/************* Registers for Output Port Lookup *******************/
`define ICING_LOOKUP_REG_ADDR_WIDTH              `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
`define ICING_LOOKUP_BLOCK_ADDR_WIDTH            `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
`define ICING_LOOKUP_BLOCK_ADDR                  `ICING_LOOKUP_BLOCK_ADDR_WIDTH'h8
`define ICING_LOOKUP_BLOCK_TAG                   ({`UDP_BLOCK_SIZE_64_TAG, `ICING_LOOKUP_BLOCK_ADDR})

`define ICING_NUM_BAD_MACS                       `ICING_LOOKUP_REG_ADDR_WIDTH'h0
`define ICING_NUM_BAD_ETHTYPES                   `ICING_LOOKUP_REG_ADDR_WIDTH'h1
`define ICING_NUM_BAD_PATH_IDX                   `ICING_LOOKUP_REG_ADDR_WIDTH'h2
`define ICING_NUM_BAD_PATH_LEN                   `ICING_LOOKUP_REG_ADDR_WIDTH'h3
`define ICING_NUM_BAD_PKT_LEN                    `ICING_LOOKUP_REG_ADDR_WIDTH'h4
`define ICING_NUM_BAD_VERSION                    `ICING_LOOKUP_REG_ADDR_WIDTH'h5
`define ICING_NUM_KEY_MISSES                     `ICING_LOOKUP_REG_ADDR_WIDTH'h6
`define ICING_NUM_PKTS_AUTHORIZED                `ICING_LOOKUP_REG_ADDR_WIDTH'h7
`define ICING_NUM_PKTS_NOT_AUTHORIZED            `ICING_LOOKUP_REG_ADDR_WIDTH'h8
`define ICING_NUM_SNDRS_NOT_AUTHORIZED           `ICING_LOOKUP_REG_ADDR_WIDTH'h9

`define ICING_MY_REALM_ID_BASE                   `ICING_LOOKUP_REG_ADDR_WIDTH'ha
`define ICING_PORT_MAC_BASE                      `ICING_MY_REALM_ID_BASE + `ICING_LOOKUP_REG_ADDR_WIDTH'd5

`define ICING_NUM_BAD_MACS_REG                   (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_NUM_BAD_MACS})
`define ICING_NUM_BAD_ETHTYPES_REG               (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_NUM_BAD_ETHTYPES})
`define ICING_NUM_BAD_PATH_IDX_REG               (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_NUM_BAD_PATH_IDX})
`define ICING_NUM_BAD_PATH_LEN_REG               (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_NUM_BAD_PATH_LEN})
`define ICING_NUM_BAD_PKT_LEN_REG                (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_NUM_BAD_PKT_LEN})
`define ICING_NUM_BAD_VERSION_REG                (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_NUM_BAD_VERSION})
`define ICING_NUM_PKTS_AUTHORIZED_REG            (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_NUM_PKTS_AUTHORIZED})
`define ICING_NUM_PKTS_NOT_AUTHORIZED_REG        (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_NUM_PKTS_NOT_AUTHORIZED})
`define ICING_NUM_SNDRS_NOT_AUTHORIZED_REG       (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_NUM_SNDRS_NOT_AUTHORIZED})
`define ICING_NUM_KEY_MISSES_REG                 (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_NUM_KEY_MISSES})

`define ICING_MY_REALM_ID_BASE_REG               (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_MY_REALM_ID_BASE})
`define ICING_PORT_MAC_BASE_REG                  (`UDP_BASE_ADDRESS | {`ICING_LOOKUP_BLOCK_TAG, `ICING_PORT_MAC_BASE})

`define PRINT_USER_REG_ADDRESSES_0                                                                                                \
$fwrite(c_reg_defines_fd, "#define ICING_NUM_BAD_MACS_REG                 0x%07x\n", `ICING_NUM_BAD_MACS_REG<<2);                 \
$fwrite(c_reg_defines_fd, "#define ICING_NUM_BAD_ETHTYPES_REG             0x%07x\n", `ICING_NUM_BAD_ETHTYPES_REG<<2);             \
$fwrite(c_reg_defines_fd, "#define ICING_NUM_BAD_PATH_IDX_REG             0x%07x\n", `ICING_NUM_BAD_PATH_IDX_REG<<2);             \
$fwrite(c_reg_defines_fd, "#define ICING_NUM_BAD_PATH_LEN_REG             0x%07x\n", `ICING_NUM_BAD_PATH_LEN_REG<<2);             \
$fwrite(c_reg_defines_fd, "#define ICING_NUM_BAD_PKT_LEN_REG              0x%07x\n", `ICING_NUM_BAD_PKT_LEN_REG<<2);              \
$fwrite(c_reg_defines_fd, "#define ICING_NUM_BAD_VERSION_REG              0x%07x\n", `ICING_NUM_BAD_VERSION_REG<<2);              \
$fwrite(c_reg_defines_fd, "#define ICING_NUM_KEY_MISSES_REG               0x%07x\n\n", `ICING_NUM_KEY_MISSES_REG<<2);             \
$fwrite(c_reg_defines_fd, "#define ICING_NUM_PKTS_AUTHORIZED_REG          0x%07x\n", `ICING_NUM_PKTS_AUTHORIZED_REG<<2);          \
$fwrite(c_reg_defines_fd, "#define ICING_NUM_PKTS_NOT_AUTHORIZED_REG      0x%07x\n", `ICING_NUM_PKTS_NOT_AUTHORIZED_REG<<2);      \
$fwrite(c_reg_defines_fd, "#define ICING_NUM_SNDRS_NOT_AUTHORIZED_REG     0x%07x\n", `ICING_NUM_SNDRS_NOT_AUTHORIZED_REG<<2);     \
$fwrite(c_reg_defines_fd, "#define ICING_MY_REALM_ID_BASE_REG             0x%07x\n", `ICING_MY_REALM_ID_BASE_REG<<2);             \
$fwrite(c_reg_defines_fd, "#define ICING_PORT_MAC_BASE_REG                0x%07x\n\n", `ICING_PORT_MAC_BASE_REG<<2)

/************* Registers for UHF Table *******************/
`define ICING_UHF_REG_ADDR_WIDTH                 `UDP_BLOCK_SIZE_64k_REG_ADDR_WIDTH
`define ICING_UHF_BLOCK_ADDR_WIDTH               `UDP_BLOCK_SIZE_64k_BLOCK_ADDR_WIDTH
`define ICING_UHF_BLOCK_ADDR                     `ICING_UHF_BLOCK_ADDR_WIDTH'h1
`define ICING_UHF_BLOCK_TAG                      ({`UDP_BLOCK_SIZE_64k_TAG, `ICING_UHF_BLOCK_ADDR})

/* num bytes = 8 bytepos/input word * 256 addresses/bytepos * 8 bytes/addr */
`define ICING_UHF_NUM_BYTES                      256*8*8
`define ICING_UHF_BASE_REG                       (`UDP_BASE_ADDRESS | {`ICING_UHF_BLOCK_TAG, `ICING_UHF_REG_ADDR_WIDTH'h0})

`define PRINT_USER_REG_ADDRESSES_1 `PRINT_USER_REG_ADDRESSES_0;                                                          \
  $display("%x, %x, %x\n", `UDP_BASE_ADDRESS, `ICING_UHF_BLOCK_TAG, `ICING_UHF_REG_ADDR_WIDTH); \
$fwrite(c_reg_defines_fd, "#define ICING_UHF_NUM_BYTES                      %07d\n", `ICING_UHF_NUM_BYTES);          \
$fwrite(c_reg_defines_fd, "#define ICING_UHF_BASE_REG                     0x%07x\n\n", `ICING_UHF_BASE_REG<<2)

/************* Registers for SRAM Tables *******************/
`define SRAM_SKEY_NXTHOP_IDX_SIZE 15
`define SRAM_SKEY_NXTHOP_ENTRY_BITS 3

`define VNODE_WIDTH 16
`define POC_KEY_ENTRY_BITS 2

`define SRAM_SKEY_NXTHOP_BASE                    {1'b0, {(`SRAM_ADDR_WIDTH-1){1'b0}}}
`define SRAM_POC_KEY_BASE                        {1'b1, {(`SRAM_ADDR_WIDTH-1){1'b0}}}

`define SRAM_SKEY_NXTHOP_BASE_REG                (`SRAM_BASE_ADDR_REG | {`SRAM_SKEY_NXTHOP_BASE, 1'b0})
`define SRAM_POC_KEY_BASE_REG                    (`SRAM_BASE_ADDR_REG | {`SRAM_POC_KEY_BASE, 1'b0})

`define PRINT_USER_REG_ADDRESSES `PRINT_USER_REG_ADDRESSES_1;                                                          \
$fwrite(c_reg_defines_fd, "#define SRAM_SKEY_NXTHOP_IDX_SIZE                %07d\n", `SRAM_SKEY_NXTHOP_IDX_SIZE);          \
$fwrite(c_reg_defines_fd, "#define SRAM_SKEY_NXTHOP_ENTRY_BITS              %07d\n", `SRAM_SKEY_NXTHOP_ENTRY_BITS+1);          \
$fwrite(c_reg_defines_fd, "#define SRAM_SKEY_NXTHOP_BASE_REG              0x%07x\n\n", `SRAM_SKEY_NXTHOP_BASE_REG<<2); \
$fwrite(c_reg_defines_fd, "#define VNODE_WIDTH                              %07d\n", `VNODE_WIDTH);          \
$fwrite(c_reg_defines_fd, "#define POC_KEY_ENTRY_BITS                       %07d\n", `POC_KEY_ENTRY_BITS+1);          \
$fwrite(c_reg_defines_fd, "#define SRAM_POC_KEY_BASE_REG                  0x%07x\n\n", `SRAM_POC_KEY_BASE_REG<<2)

