#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include "ocb.h"

byte tag[16];
int gb_print = 0;

static void inline parse_arg(char *arg, byte* buf) {
  /* allocate in bytes and copy data */
  while(*arg) {
    sscanf(arg, "%2hhx", buf);
    arg+=2; buf++;
  }
}

int main(int argc, char *argv[]) {
  int retval = 0;
  int mlen, klen;
  byte *data;
  byte *tag_ptr;
  byte key[16];
  int i;
  ocb_state *state;

  /* require two args key, data */
  if(argc < 3) {
    printf("Need two args: key and data in hex");
    exit(1);
  }

  if(argc > 3) {
    gb_print = 1;
  }

  /* get the key */
  klen = strlen(argv[1]);
  if(klen != 32) {
    printf("Key must be 16 bytes");
    exit(1);
  }
  parse_arg(argv[1], key);

  /* 2 hex digits per byte */
  mlen = strlen(argv[2]);
  if(mlen & 1) {
    printf("Num hex digits must be even");
    exit(1);
  }
  mlen /= 2;
  data = (byte *) malloc(mlen);
  parse_arg(argv[2], data);

  /* Calculate the PMAC and print it */
  state = ocb_init(key, 16, 16, AES128);
  pmac_function(data, mlen, tag, state);

  tag_ptr = tag;
  for(i = 0; i < 16; i++) {
    printf("%02x", 0xff&(*tag_ptr++));
  }
  printf("\n");
  return retval;
}
