#!/usr/bin/perl -w

use strict;
use warnings;
use List::Util qw(min);

# path_len -> path_idx -> payload_size
my %experiment = (
		  3 => { 1 => [0, 1514]},
		  7 => { 1 => [0, 1514],
			 3 => [0, 256, 512, 1024, 1514],
			},
		  10 => { 1 => [0, 1514],
			},
		  20 => { 1 => [0, 1514],
			  5 => [0],
			  10 => [0],
			  15 => [0],
			  18 => [0],
			},
		  30 => { 1 => [0, 1514],
			},
		  37 => { 1 => [0, 1514]},
		 );
unlink "lat_run";

foreach my $path_len (keys %experiment) {
  my %idx_hash = %{$experiment{$path_len}};
  foreach my $path_idx (keys %idx_hash) {
    my @payload_lens = @{$idx_hash{$path_idx}};
    foreach my $payload_len (@payload_lens) {
      my $run_str = "nf_packet_generator.pl ";
      my $overhead_len = 14 + 14 + ($path_len-1)*40 + 24;
      $payload_len = min(1514-$overhead_len,  $payload_len);
      my $num_pkts = 200;
      foreach my $port (0,2) {
        $run_str = $run_str . "-q$port ~jnaous/pkt.$path_idx.$path_len.$payload_len.$port.pcap -i$port $num_pkts ";
      }
      $run_str = $run_str . "-c1 ~jnaous/latency.$path_idx.$path_len.$payload_len.noicing.pcap -c2 ~jnaous/latency.$path_idx.$path_len.$payload_len.icing.pcap ";
      system("echo '$run_str' >> lat_run");
    }
  }
}
