#!/usr/bin/perl -w

use strict;
use warnings;
use List::Util qw(min);

# path_len -> path_idx -> payload_size
my %experiment = (
		  3 => { 1 => [0, 1514]},
		  7 => { 1 => [0, 1514],
			 3 => [0, 256, 512, 1024, 1514],
			},
		  10 => { 1 => [0, 1514],
			},
		  20 => { 1 => [0, 1514],
			  5 => [0],
			  10 => [0],
			  15 => [0],
			  18 => [0],
			},
		  30 => { 1 => [0, 1514],
			},
		  35 => { 1 => [0, 1514]},
		 );

my $time = 120; # seconds
my $num_hosts = 4;
my $host_num_start = 33;
my $exp_num = 0;

foreach my $i(0..$num_hosts-1) {
  my $host = $host_num_start+$i*2;
  unlink("nfcm${host}.run");
}

foreach my $path_len (keys %experiment) {
  my %idx_hash = %{$experiment{$path_len}};
  foreach my $path_idx (keys %idx_hash) {
    my @payload_lens = @{$idx_hash{$path_idx}};
    foreach my $payload_len (@payload_lens) {
      my $run_str = "sleep 1 ; nf_packet_generator.pl ";
      my $overhead_len = 14 + 14 + ($path_len-1)*40 + 24;
      $payload_len = min(1514-$overhead_len,  $payload_len);
      my $total_len = $overhead_len + $payload_len + 20;
      my $num_pkts_per_sec = 10**9 / $total_len / 8;
      my $num_pkts = $time * $num_pkts_per_sec;
      foreach my $port (0..3) {
        $run_str = $run_str . "-q$port ~jnaous/pkt.$path_idx.$path_len.$payload_len.$port.pcap -i$port $num_pkts ";
      }
      $run_str = $run_str . " | tee result.$path_idx.$path_len.$payload_len";
      `echo result.$path_idx.$path_len.$payload_len >> result_list`;
      my $host = ($host_num_start+($exp_num%$num_hosts)*2);
      system("echo '$run_str' >> nfcm${host}.run");
      $exp_num++;
    }
  }
}

# foreach my $i(0..$num_hosts-1) {
#   my $host = $host_num_start+$i*2;
#   print "Setting up nfcm$host\n";
#   system("scp nfcm${host}.run nfcm${host}:");
#   system("ssh nfcm${host} 'sudo nf2_download /usr/share/netfpga/bitfiles/packet_generator.bit'");
# }

# foreach my $i(0..$num_hosts-1) {
#   my $host = $host_num_start+$i*2-1;
#   print "Setting up nfcm$host\n";
#   system("ssh nfcm${host} 'sudo nf2_download /home/icing/nfs/NF2/icing2_forwarder_vanilla.bit'");
#   system("ssh nfcm${host} 'sudo /home/icing/nfs/NF2/projects/icing2_forwarder/sw/cli -c 10 -w 10'");
# }

