module buffer
  #(parameter WIDTH = 64)
    (// --- Interface to sender
     input     [0:WIDTH-1]  din,
     input                  din_vld,
     output                 din_ack,

     // --- Interface to receiver
     output     [0:WIDTH-1] dout,
     output                 dout_vld,
     input                  dout_ack,
     
     input                  reset,
     input                  clk
     );

   fallthrough_small_fifo 
     #(.WIDTH(WIDTH),
       .MAX_DEPTH_BITS(1))
      buf_fifo
        (.full          (full),
         .empty         (empty),
         .wr_en         (din_ack),
         .rd_en         (dout_ack),
         .din           (din),
         .dout          (dout),
         .prog_full     (),
         .nearly_full   (),
         .reset         (reset),
         .clk           (clk)
         );

   assign din_ack = din_vld && !full;
   assign dout_vld = !empty;

endmodule
