#!/bin/bash
set -o errexit
set -o nounset

all=ping_list-all.txt
rm -f $all
min_team=1
max_team=5
teams=(`echo "1 2 3 4 5"`)
for team in ${teams[@]}; do
    out=ping_list-group$team

    # remove any old ping list file
    rm -f $out

    # get the previous lower team
    if [ $team -eq $min_team ]; then
        prev=$max_team
    else
        prev=`echo "$team - 1" | bc`
    fi

    # on the 10.10/16 network, ping the previous team
    echo "10.10.0.0     255.255.0.0    10.10.0.$prev" >> $out

    # for all other subnets, ping the x.y.z.1 address except the one we own
    # which is x.y.$team.1 (instead ping x.y.$team.2)
    t=0
    while [ $t -lt $max_team ]; do
        t=`echo "$t + 1" | bc`
        if [ $t -eq $team ]; then
            echo "192.168.$t.0   255.255.255.0  192.168.$t.2" >> $out
        else
            echo "192.168.$t.0   255.255.255.0  192.168.$t.1" >> $out
        fi
        echo "192.168.1$t.0  255.255.255.0  192.168.1$t.2" >> $out
    done

    echo "# ------------------- group $team ------------------- #" >> $all
    cat $out >> $all
done
