/** Filename: protocol.c */

#include <netinet/in.h>
#include <stdlib.h>
#include <sys/socket.h>
#include "protocol.h"

int monitor_init() {
    int fd;

    /* make a UDP socket to send data to the server on */
    if( (fd = socket( AF_INET, SOCK_DGRAM, IPPROTO_UDP )) == -1 ) {
        perror( "Error: unable to create UDP socket" );
        exit( 1 );
    }

    /* allow reuse of the port */
    int reuse = 1;
    if( setsockopt( fd, SOL_SOCKET, SO_REUSEADDR, &reuse, sizeof(reuse) ) ) {
        perror( "Error: SO_REUSEADDR failed" );
        exit( 1 );
    }

    /* bind to the socket */
    struct sockaddr_in sin;
    sin.sin_family = AF_INET;
    sin.sin_port = htons( SR_MONITOR_PORT );
    sin.sin_addr.s_addr = INADDR_ANY;
    if( bind( fd, (struct sockaddr *)&sin, sizeof(sin) ) == -1 ) {
        perror( "Error: bind failed to UDP SR Monitor Port" );
        exit( 1 );
    }

    return fd;
}
