/**
 * Filename: server_pres.h
 * Purpose: define methods for generating a presentation of client data
 */

#ifndef SERVER_PRES_H
#define SERVER_PRES_H

typedef struct {
    unsigned start_time;     /* time the server started */
    unsigned update_count;   /* number of received updates */
    const char* output_path; /* where to put the generated files */
    char mv_cmd[512];
} pres_info_t;

/* forward declaration */
struct server_t;

/**
 * This method re-generates all presentation information.  The server lock must
 * be held by the calller.
 */
void refresh_presentation( struct server_t* server );

#endif /* SERVER_PRES_H */
