 /* Register macros */
 `define HARDWIRE_LOOKUP_REG_ADDR_WIDTH       `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
 `define HARDWIRE_LOOKUP_BLOCK_ADDR_WIDTH     `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
 `define HARDWIRE_LOOKUP_BLOCK_ADDR           `HARDWIRE_LOOKUP_BLOCK_ADDR_WIDTH'h8
 `define HARDWIRE_LOOKUP_BLOCK_TAG            ({`UDP_BLOCK_SIZE_64_TAG, `HARDWIRE_LOOKUP_BLOCK_ADDR})

 `define ENCAP_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
 `define ENCAP_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
 `define ENCAP_BLOCK_ADDR                   `ENCAP_BLOCK_ADDR_WIDTH'h9
 `define ENCAP_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `ENCAP_BLOCK_ADDR})

 `define DECAP_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
 `define DECAP_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
 `define DECAP_BLOCK_ADDR                   `DECAP_BLOCK_ADDR_WIDTH'hA
 `define DECAP_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `DECAP_BLOCK_ADDR})

 `define DEBUG_COUNTERS_REG_ADDR_WIDTH      `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
 `define DEBUG_COUNTERS_BLOCK_ADDR_WIDTH    `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
 `define DEBUG_COUNTERS_BLOCK_ADDR          `DEBUG_COUNTERS_BLOCK_ADDR_WIDTH'hB
 `define DEBUG_COUNTERS_BLOCK_TAG           ({`UDP_BLOCK_SIZE_64_TAG, `DEBUG_COUNTERS_BLOCK_ADDR})

 /* Internal register addresses */
 `define HARDWIRE_OUTPUT_PORTS_BASE           `HARDWIRE_LOOKUP_REG_ADDR_WIDTH'h0

 `define DEBUG_COUNTERS_PKTS_IN_RATE_LIMITER  `DEBUG_COUNTERS_REG_ADDR_WIDTH'h0
 `define DEBUG_COUNTERS_PKTS_IN_OUTPUT_QUEUES `DEBUG_COUNTERS_REG_ADDR_WIDTH'h1
 `define DEBUG_COUNTERS_PKTS_IN_IP_FIXER      `DEBUG_COUNTERS_REG_ADDR_WIDTH'h2
 `define DEBUG_COUNTERS_PKTS_IN_ENCAP         `DEBUG_COUNTERS_REG_ADDR_WIDTH'h3
 `define DEBUG_COUNTERS_PKTS_IN_EVT_CAP       `DEBUG_COUNTERS_REG_ADDR_WIDTH'h4
 `define DEBUG_COUNTERS_PKTS_IN_OPL           `DEBUG_COUNTERS_REG_ADDR_WIDTH'h5
 `define DEBUG_COUNTERS_PKTS_IN_DECAP         `DEBUG_COUNTERS_REG_ADDR_WIDTH'h6

 /*ENCAP Module */
 `define ENCAP_ENABLE                      `ENCAP_REG_ADDR_WIDTH'h2
 `define ENCAP_IP_DATA_0                   `ENCAP_REG_ADDR_WIDTH'h3
 `define ENCAP_IP_DATA_1                   `ENCAP_REG_ADDR_WIDTH'h4
 `define ENCAP_IP_DATA_2                   `ENCAP_REG_ADDR_WIDTH'h5
 `define ENCAP_IP_DATA_3                   `ENCAP_REG_ADDR_WIDTH'h6
 `define ENCAP_IP_DATA_4                   `ENCAP_REG_ADDR_WIDTH'h7
 `define ENCAP_IP_DATA_5                   `ENCAP_REG_ADDR_WIDTH'h8
 `define ENCAP_PORT_MASK                   `ENCAP_REG_ADDR_WIDTH'h9
 `define ENCAP_NUM_PACKET_IN               `ENCAP_REG_ADDR_WIDTH'ha
 `define ENCAP_NUM_PACKET_OUT              `ENCAP_REG_ADDR_WIDTH'hb
 `define ENCAP_NUM_BYTES_IN                `ENCAP_REG_ADDR_WIDTH'hc
 `define ENCAP_NUM_BYTES_OUT               `ENCAP_REG_ADDR_WIDTH'hd

 /*DECAP Module */
 `define DECAP_NUM_WORD_IN                  `DECAP_REG_ADDR_WIDTH'h4
 `define DECAP_NUM_WORD_OUT                 `DECAP_REG_ADDR_WIDTH'h5
 `define DECAP_VALID_TUNNELING              `DECAP_REG_ADDR_WIDTH'h6
 `define DECAP_USER_DATA_PATH_HEADER        `DECAP_REG_ADDR_WIDTH'h7
 `define DECAP_NUM_PACKET_IN                `DECAP_REG_ADDR_WIDTH'h8
 `define DECAP_NUM_PACKET_OUT               `DECAP_REG_ADDR_WIDTH'h9

 // ENCAP
 `define ENCAP_ENABLE_REG                      (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_ENABLE})
 `define ENCAP_IP_DATA_0_REG                   (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_IP_DATA_0})
 `define ENCAP_IP_DATA_1_REG                   (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_IP_DATA_1})
 `define ENCAP_IP_DATA_2_REG                   (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_IP_DATA_2})
 `define ENCAP_IP_DATA_3_REG                   (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_IP_DATA_3})
 `define ENCAP_IP_DATA_4_REG                   (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_IP_DATA_4})
 `define ENCAP_IP_DATA_5_REG                   (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_IP_DATA_5})
 `define ENCAP_PORT_MASK_REG                   (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_PORT_MASK})
 `define ENCAP_NUM_PACKET_IN_REG               (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_NUM_PACKET_IN})
 `define ENCAP_NUM_PACKET_OUT_REG              (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_NUM_PACKET_OUT})
 `define ENCAP_NUM_BYTES_IN_REG                (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_NUM_BYTES_IN})
 `define ENCAP_NUM_BYTES_OUT_REG               (`UDP_BASE_ADDRESS  | {`ENCAP_BLOCK_TAG, `ENCAP_NUM_BYTES_OUT})

 //DECAP
 `define DECAP_NUM_WORD_IN_REG                (`UDP_BASE_ADDRESS | {`DECAP_BLOCK_TAG, `DECAP_NUM_WORD_IN})
 `define DECAP_NUM_WORD_OUT_REG               (`UDP_BASE_ADDRESS | {`DECAP_BLOCK_TAG, `DECAP_NUM_WORD_OUT})
 `define DECAP_VALID_TUNNELING_REG            (`UDP_BASE_ADDRESS | {`DECAP_BLOCK_TAG, `DECAP_VALID_TUNNELING})
 `define DECAP_USER_DATA_PATH_HEADER_REG      (`UDP_BASE_ADDRESS | {`DECAP_BLOCK_TAG, `DECAP_USER_DATA_PATH_HEADER})
 `define DECAP_NUM_PACKET_IN_REG              (`UDP_BASE_ADDRESS | {`DECAP_BLOCK_TAG, `DECAP_NUM_PACKET_IN})
 `define DECAP_NUM_PACKET_OUT_REG             (`UDP_BASE_ADDRESS | {`DECAP_BLOCK_TAG, `DECAP_NUM_PACKET_OUT})

 `define HARDWIRE_OUTPUT_PORTS_BASE_REG       (`UDP_BASE_ADDRESS | {`HARDWIRE_LOOKUP_BLOCK_TAG, `HARDWIRE_OUTPUT_PORTS_BASE})

 `define DEBUG_COUNTERS_PKTS_IN_RATE_LIMITER_REG  (`UDP_BASE_ADDRESS | {`DEBUG_COUNTERS_BLOCK_TAG, `DEBUG_COUNTERS_PKTS_IN_RATE_LIMITER})
 `define DEBUG_COUNTERS_PKTS_IN_OUTPUT_QUEUES_REG (`UDP_BASE_ADDRESS | {`DEBUG_COUNTERS_BLOCK_TAG, `DEBUG_COUNTERS_PKTS_IN_OUTPUT_QUEUES})
 `define DEBUG_COUNTERS_PKTS_IN_IP_FIXER_REG      (`UDP_BASE_ADDRESS | {`DEBUG_COUNTERS_BLOCK_TAG, `DEBUG_COUNTERS_PKTS_IN_IP_FIXER})
 `define DEBUG_COUNTERS_PKTS_IN_ENCAP_REG         (`UDP_BASE_ADDRESS | {`DEBUG_COUNTERS_BLOCK_TAG, `DEBUG_COUNTERS_PKTS_IN_ENCAP})
 `define DEBUG_COUNTERS_PKTS_IN_EVT_CAP_REG       (`UDP_BASE_ADDRESS | {`DEBUG_COUNTERS_BLOCK_TAG, `DEBUG_COUNTERS_PKTS_IN_EVT_CAP})
 `define DEBUG_COUNTERS_PKTS_IN_OPL_REG           (`UDP_BASE_ADDRESS | {`DEBUG_COUNTERS_BLOCK_TAG, `DEBUG_COUNTERS_PKTS_IN_OPL})
 `define DEBUG_COUNTERS_PKTS_IN_DECAP_REG         (`UDP_BASE_ADDRESS | {`DEBUG_COUNTERS_BLOCK_TAG, `DEBUG_COUNTERS_PKTS_IN_DECAP})

 `define PRINT_USER_REG_ADDRESSES                                                                                                                   \
         $fwrite(c_reg_defines_fd, "#define DECAP_NUM_WORD_IN_REG                       0x%07x\n", `DECAP_NUM_WORD_IN_REG<<2);                      \
         $fwrite(c_reg_defines_fd, "#define DECAP_NUM_WORD_OUT_REG                      0x%07x\n", `DECAP_NUM_WORD_OUT_REG<<2);                     \
         $fwrite(c_reg_defines_fd, "#define DECAP_VALID_TUNNELING_REG                   0x%07x\n", `DECAP_VALID_TUNNELING_REG<<2);                  \
         $fwrite(c_reg_defines_fd, "#define DECAP_USER_DATA_PATH_HEADER_REG             0x%07x\n", `DECAP_USER_DATA_PATH_HEADER_REG<<2);            \
         $fwrite(c_reg_defines_fd, "#define DECAP_NUM_PACKET_IN_REG                     0x%07x\n", `DECAP_NUM_PACKET_IN_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define DECAP_NUM_PACKET_OUT_REG                    0x%07x\n", `DECAP_NUM_PACKET_OUT_REG<<2);                   \
         $fwrite(c_reg_defines_fd, "#define ENCAP_NUM_PACKET_IN_REG                     0x%07x\n", `ENCAP_NUM_PACKET_IN_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_NUM_PACKET_OUT_REG                    0x%07x\n", `ENCAP_NUM_PACKET_OUT_REG<<2);                   \
         $fwrite(c_reg_defines_fd, "#define ENCAP_NUM_BYTES_IN_REG                      0x%07x\n", `ENCAP_NUM_BYTES_IN_REG<<2);                     \
         $fwrite(c_reg_defines_fd, "#define ENCAP_NUM_BYTES_OUT_REG                     0x%07x\n", `ENCAP_NUM_BYTES_OUT_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_ENABLE_REG                            0x%07x\n", `ENCAP_ENABLE_REG<<2);                           \
         $fwrite(c_reg_defines_fd, "#define ENCAP_IP_DATA_0_REG                         0x%07x\n", `ENCAP_IP_DATA_0_REG<<2);                        \
         $fwrite(c_reg_defines_fd, "#define ENCAP_IP_DATA_1_REG                         0x%07x\n", `ENCAP_IP_DATA_1_REG<<2);                        \
         $fwrite(c_reg_defines_fd, "#define ENCAP_IP_DATA_2_REG                         0x%07x\n", `ENCAP_IP_DATA_2_REG<<2);                        \
         $fwrite(c_reg_defines_fd, "#define ENCAP_IP_DATA_3_REG                         0x%07x\n", `ENCAP_IP_DATA_3_REG<<2);                        \
         $fwrite(c_reg_defines_fd, "#define ENCAP_IP_DATA_4_REG                         0x%07x\n", `ENCAP_IP_DATA_4_REG<<2);                        \
         $fwrite(c_reg_defines_fd, "#define ENCAP_IP_DATA_5_REG                         0x%07x\n", `ENCAP_IP_DATA_5_REG<<2);                        \
         $fwrite(c_reg_defines_fd, "#define ENCAP_PORT_MASK_REG                         0x%07x\n\n", `ENCAP_PORT_MASK_REG<<2);                      \
                                                                                                                                                    \
         $fwrite(c_reg_defines_fd, "#define HARDWIRE_OUTPUT_PORTS_BASE_REG              0x%07x\n\n", `HARDWIRE_OUTPUT_PORTS_BASE_REG<<2);           \
                                                                                                                                                    \
         $fwrite(c_reg_defines_fd, "#define DEBUG_COUNTERS_PKTS_IN_RATE_LIMITER_REG     0x%07x\n", `DEBUG_COUNTERS_PKTS_IN_RATE_LIMITER_REG<<2);    \
         $fwrite(c_reg_defines_fd, "#define DEBUG_COUNTERS_PKTS_IN_OUTPUT_QUEUES_REG    0x%07x\n", `DEBUG_COUNTERS_PKTS_IN_OUTPUT_QUEUES_REG<<2);   \
         $fwrite(c_reg_defines_fd, "#define DEBUG_COUNTERS_PKTS_IN_IP_FIXER_REG         0x%07x\n", `DEBUG_COUNTERS_PKTS_IN_IP_FIXER_REG<<2);        \
         $fwrite(c_reg_defines_fd, "#define DEBUG_COUNTERS_PKTS_IN_ENCAP_REG            0x%07x\n", `DEBUG_COUNTERS_PKTS_IN_ENCAP_REG<<2);           \
         $fwrite(c_reg_defines_fd, "#define DEBUG_COUNTERS_PKTS_IN_EVT_CAP_REG          0x%07x\n", `DEBUG_COUNTERS_PKTS_IN_EVT_CAP_REG<<2);         \
         $fwrite(c_reg_defines_fd, "#define DEBUG_COUNTERS_PKTS_IN_OPL_REG              0x%07x\n", `DEBUG_COUNTERS_PKTS_IN_OPL_REG<<2);             \
         $fwrite(c_reg_defines_fd, "#define DEBUG_COUNTERS_PKTS_IN_DECAP_REG            0x%07x\n\n", `DEBUG_COUNTERS_PKTS_IN_DECAP_REG<<2)
