/******************************************************
 * vim:set shiftwidth=3 softtabstop=3 expandtab:
 * $Id$
 * filename:  eop_signal.v
 * author:    Jad Naous
 * Summary:   sends a pulse when an end-of-pkt is seen
 ******************************************************/

module eop_signal
    #(parameter DATA_WIDTH = 64,
      parameter CTRL_WIDTH=DATA_WIDTH/8)

   (// --- data path interface
    input  [CTRL_WIDTH-1:0]            in_ctrl,
    input                              in_wr,

    output reg                         eop,

    // --- Misc
    input                              clk,
    input                              reset);

   reg in_ctrl_prev_is_zero;

   always @(posedge clk) begin
      if(reset) begin
         in_ctrl_prev_is_zero    <= 0;
         eop                     <= 0;
      end
      else begin
         eop    <= 0;
         if(in_wr) begin
            in_ctrl_prev_is_zero    <= (in_ctrl == 0);
            eop                     <= in_ctrl_prev_is_zero 
                                       && (in_ctrl != 0);
         end
      end
   end // always @ (posedge clk)

endmodule // eop_signal
