#!/usr/local/bin/perl -w
# make_pkts.pl
#

use NF2::PacketGen;
use NF2::PacketLib;
use NF21RouterLib;
require "reg_defines.ph";
require "reg_defines_router_ip_tuneling.ph";
$delay = '@4us';
$batch = 0;
nf_set_environment( { PORT_MODE => 'PHYSICAL', MAX_PORTS => 4 } );

# use strict AFTER the $delay, $batch and %reg are declared
use strict;
use vars qw($delay $batch %reg);

# Prepare the DMA and enable interrupts
prepare_DMA('@3.9us');
enable_interrupts(0);

my $length = 100;
my $DA_sub = ':dd:dd:dd:dd:dd';
my $SA_sub = ':55:55:55:55:55';
my $DA;
my $SA;
my $pkt;
my $in_port;
my $out_port;
my $i = 0;
my $temp;

$delay = '@6us';

# # set it up so that you send each packet out the same way it came in
# for($i=0; $i<8; $i++) {
#   nf_PCI_write32($delay, 0, HARDWIRE_OUTPUT_PORTS_BASE_REG()+$i*4, 1<<$i);
# }

# # send and receive 3 pkts into each port
# $delay = '@17us';
# $length = 60;
# for($i=0; $i<12; $i++){
#   $temp = sprintf("%02x", $i);
#   $DA = $temp . $DA_sub;
#   $SA = $temp . $SA_sub;
#   $in_port = ($i%4) + 1;
#   $pkt = make_IP_pkt($length, $DA, $SA, 64, '192.168.0.1', '192.168.0.2');

#   nf_packet_in($in_port, $length, $delay, $batch,  $pkt);
#   nf_expected_packet($in_port, $length, $pkt);

#   nf_dma_data_in($length, $delay, $in_port, $pkt);
#   nf_expected_dma_data($in_port, $length, $pkt);
# }

$delay = '@6us';
# set it up so that you send each packet out the next port
for($i=0; $i<8; $i++) {
  nf_PCI_write32($delay, 0, HARDWIRE_OUTPUT_PORTS_BASE_REG()+$i*4, 1<<(($i+2)%8));
}

# send and receive 3 pkts into each port
$delay = '@17us';
$length = 60;
for($i=0; $i<12; $i++){
  $temp = sprintf("%02x", $i);
  $DA = $temp . $DA_sub;
  $SA = $temp . $SA_sub;
  $in_port = ($i%4) + 1;
  $pkt = make_IP_pkt($length, $DA, $SA, 64, '192.168.0.1', '192.168.0.2');

  nf_packet_in($in_port, $length, $delay, $batch,  $pkt);
  nf_expected_packet(($in_port%4) + 1, $length, $pkt);

  nf_dma_data_in($length, $delay, $in_port, $pkt);
  nf_expected_dma_data(($in_port%4) + 1, $length, $pkt);
}

# *********** Finishing Up - need this in all scripts ! ****************************
my $t = nf_write_sim_files();
print  "--- make_pkts.pl: Generated all configuration packets.\n";
printf "--- make_pkts.pl: Last packet enters system at approx %0d microseconds.\n",($t/1000);
if (nf_write_expected_files()) {
  die "Unable to write expected files\n";
}

nf_create_hardware_file('LITTLE_ENDIAN');
nf_write_hardware_file('LITTLE_ENDIAN');
