 /* Register macros */
 `define HARDWIRE_LOOKUP_REG_ADDR_WIDTH       `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
 `define HARDWIRE_LOOKUP_BLOCK_ADDR_WIDTH     `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
 `define HARDWIRE_LOOKUP_BLOCK_ADDR           `HARDWIRE_LOOKUP_BLOCK_ADDR_WIDTH'h8
 `define HARDWIRE_LOOKUP_BLOCK_TAG            ({`UDP_BLOCK_SIZE_64_TAG, `HARDWIRE_LOOKUP_BLOCK_ADDR})

 `define ENCAP_1_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
 `define ENCAP_1_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
 `define ENCAP_1_BLOCK_ADDR                   `ENCAP_1_BLOCK_ADDR_WIDTH'h9
 `define ENCAP_1_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `ENCAP_1_BLOCK_ADDR})

 `define ENCAP_2_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
 `define ENCAP_2_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
 `define ENCAP_2_BLOCK_ADDR                   `ENCAP_2_BLOCK_ADDR_WIDTH'hA
 `define ENCAP_2_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `ENCAP_2_BLOCK_ADDR})

 `define ENCAP_3_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
 `define ENCAP_3_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
 `define ENCAP_3_BLOCK_ADDR                   `ENCAP_3_BLOCK_ADDR_WIDTH'hB
 `define ENCAP_3_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `ENCAP_3_BLOCK_ADDR})

 `define ENCAP_4_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
 `define ENCAP_4_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
 `define ENCAP_4_BLOCK_ADDR                   `ENCAP_4_BLOCK_ADDR_WIDTH'hC
 `define ENCAP_4_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `ENCAP_4_BLOCK_ADDR})

 /* Internal register addresses */
 `define HARDWIRE_OUTPUT_PORTS_BASE           `HARDWIRE_LOOKUP_REG_ADDR_WIDTH'h0

 /*ENCAP Module */
 `define ENCAP_ENABLE_PORT_1               `ENCAP_1_REG_ADDR_WIDTH'h0
 `define ENCAP_PORTS_PORT_1                `ENCAP_1_REG_ADDR_WIDTH'h1

 `define ENCAP_SRC_IP_PORT_1               `ENCAP_1_REG_ADDR_WIDTH'h2
 `define ENCAP_DST_IP_PORT_1               `ENCAP_1_REG_ADDR_WIDTH'h3
 `define ENCAP_TTL_PROTO_PORT_1            `ENCAP_1_REG_ADDR_WIDTH'h4
 `define ENCAP_TOS_PORT_1                  `ENCAP_1_REG_ADDR_WIDTH'h5
 `define ENCAP_SRC_MAC_HI_PORT_1           `ENCAP_1_REG_ADDR_WIDTH'h6
 `define ENCAP_SRC_MAC_LO_PORT_1           `ENCAP_1_REG_ADDR_WIDTH'h7
 `define ENCAP_DST_MAC_HI_PORT_1           `ENCAP_1_REG_ADDR_WIDTH'h8
 `define ENCAP_DST_MAC_LO_PORT_1           `ENCAP_1_REG_ADDR_WIDTH'h9

 `define ENCAP_ENABLE_PORT_2               `ENCAP_2_REG_ADDR_WIDTH'h0
 `define ENCAP_PORTS_PORT_2                `ENCAP_2_REG_ADDR_WIDTH'h1

 `define ENCAP_SRC_IP_PORT_2               `ENCAP_2_REG_ADDR_WIDTH'h2
 `define ENCAP_DST_IP_PORT_2               `ENCAP_2_REG_ADDR_WIDTH'h3
 `define ENCAP_TTL_PROTO_PORT_2            `ENCAP_2_REG_ADDR_WIDTH'h4
 `define ENCAP_TOS_PORT_2                  `ENCAP_2_REG_ADDR_WIDTH'h5
 `define ENCAP_SRC_MAC_HI_PORT_2           `ENCAP_2_REG_ADDR_WIDTH'h6
 `define ENCAP_SRC_MAC_LO_PORT_2           `ENCAP_2_REG_ADDR_WIDTH'h7
 `define ENCAP_DST_MAC_HI_PORT_2           `ENCAP_2_REG_ADDR_WIDTH'h8
 `define ENCAP_DST_MAC_LO_PORT_2           `ENCAP_2_REG_ADDR_WIDTH'h9

 `define ENCAP_ENABLE_PORT_3               `ENCAP_3_REG_ADDR_WIDTH'h0
 `define ENCAP_PORTS_PORT_3                `ENCAP_3_REG_ADDR_WIDTH'h1

 `define ENCAP_SRC_IP_PORT_3               `ENCAP_3_REG_ADDR_WIDTH'h2
 `define ENCAP_DST_IP_PORT_3               `ENCAP_3_REG_ADDR_WIDTH'h3
 `define ENCAP_TTL_PROTO_PORT_3            `ENCAP_3_REG_ADDR_WIDTH'h4
 `define ENCAP_TOS_PORT_3                  `ENCAP_3_REG_ADDR_WIDTH'h5
 `define ENCAP_SRC_MAC_HI_PORT_3           `ENCAP_3_REG_ADDR_WIDTH'h6
 `define ENCAP_SRC_MAC_LO_PORT_3           `ENCAP_3_REG_ADDR_WIDTH'h7
 `define ENCAP_DST_MAC_HI_PORT_3           `ENCAP_3_REG_ADDR_WIDTH'h8
 `define ENCAP_DST_MAC_LO_PORT_3           `ENCAP_3_REG_ADDR_WIDTH'h9

 `define ENCAP_ENABLE_PORT_4               `ENCAP_4_REG_ADDR_WIDTH'h0
 `define ENCAP_PORTS_PORT_4                `ENCAP_4_REG_ADDR_WIDTH'h1

 `define ENCAP_SRC_IP_PORT_4               `ENCAP_4_REG_ADDR_WIDTH'h2
 `define ENCAP_DST_IP_PORT_4               `ENCAP_4_REG_ADDR_WIDTH'h3
 `define ENCAP_TTL_PROTO_PORT_4            `ENCAP_4_REG_ADDR_WIDTH'h4
 `define ENCAP_TOS_PORT_4                  `ENCAP_4_REG_ADDR_WIDTH'h5
 `define ENCAP_SRC_MAC_HI_PORT_4           `ENCAP_4_REG_ADDR_WIDTH'h6
 `define ENCAP_SRC_MAC_LO_PORT_4           `ENCAP_4_REG_ADDR_WIDTH'h7
 `define ENCAP_DST_MAC_HI_PORT_4           `ENCAP_4_REG_ADDR_WIDTH'h8
 `define ENCAP_DST_MAC_LO_PORT_4           `ENCAP_4_REG_ADDR_WIDTH'h9

 // ENCAP
 `define ENCAP_ENABLE_PORT_1_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_ENABLE_PORT_1})
 `define ENCAP_PORTS_PORT_1_REG             (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_PORTS_PORT_1})

 `define ENCAP_SRC_IP_PORT_1_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_SRC_IP_PORT_1})
 `define ENCAP_DST_IP_PORT_1_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_DST_IP_PORT_1})
 `define ENCAP_TTL_PROTO_PORT_1_REG         (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_TTL_PROTO_PORT_1})
 `define ENCAP_TOS_PORT_1_REG               (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_TOS_PORT_1})
 `define ENCAP_SRC_MAC_HI_PORT_1_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_SRC_MAC_HI_PORT_1})
 `define ENCAP_SRC_MAC_LO_PORT_1_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_SRC_MAC_LO_PORT_1})
 `define ENCAP_DST_MAC_HI_PORT_1_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_DST_MAC_HI_PORT_1})
 `define ENCAP_DST_MAC_LO_PORT_1_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_DST_MAC_LO_PORT_1})

 `define ENCAP_ENABLE_PORT_2_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_ENABLE_PORT_2})
 `define ENCAP_PORTS_PORT_2_REG             (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_PORTS_PORT_2})

 `define ENCAP_SRC_IP_PORT_2_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_SRC_IP_PORT_2})
 `define ENCAP_DST_IP_PORT_2_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_DST_IP_PORT_2})
 `define ENCAP_TTL_PROTO_PORT_2_REG         (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_TTL_PROTO_PORT_2})
 `define ENCAP_TOS_PORT_2_REG               (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_TOS_PORT_2})
 `define ENCAP_SRC_MAC_HI_PORT_2_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_SRC_MAC_HI_PORT_2})
 `define ENCAP_SRC_MAC_LO_PORT_2_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_SRC_MAC_LO_PORT_2})
 `define ENCAP_DST_MAC_HI_PORT_2_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_DST_MAC_HI_PORT_2})
 `define ENCAP_DST_MAC_LO_PORT_2_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_DST_MAC_LO_PORT_2})

 `define ENCAP_ENABLE_PORT_3_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_ENABLE_PORT_3})
 `define ENCAP_PORTS_PORT_3_REG             (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_PORTS_PORT_3})

 `define ENCAP_SRC_IP_PORT_3_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_SRC_IP_PORT_3})
 `define ENCAP_DST_IP_PORT_3_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_DST_IP_PORT_3})
 `define ENCAP_TTL_PROTO_PORT_3_REG         (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_TTL_PROTO_PORT_3})
 `define ENCAP_TOS_PORT_3_REG               (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_TOS_PORT_3})
 `define ENCAP_SRC_MAC_HI_PORT_3_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_SRC_MAC_HI_PORT_3})
 `define ENCAP_SRC_MAC_LO_PORT_3_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_SRC_MAC_LO_PORT_3})
 `define ENCAP_DST_MAC_HI_PORT_3_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_DST_MAC_HI_PORT_3})
 `define ENCAP_DST_MAC_LO_PORT_3_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_DST_MAC_LO_PORT_3})

 `define ENCAP_ENABLE_PORT_4_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_ENABLE_PORT_4})
 `define ENCAP_PORTS_PORT_4_REG             (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_PORTS_PORT_4})

 `define ENCAP_SRC_IP_PORT_4_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_SRC_IP_PORT_4})
 `define ENCAP_DST_IP_PORT_4_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_DST_IP_PORT_4})
 `define ENCAP_TTL_PROTO_PORT_4_REG         (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_TTL_PROTO_PORT_4})
 `define ENCAP_TOS_PORT_4_REG               (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_TOS_PORT_4})
 `define ENCAP_SRC_MAC_HI_PORT_4_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_SRC_MAC_HI_PORT_4})
 `define ENCAP_SRC_MAC_LO_PORT_4_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_SRC_MAC_LO_PORT_4})
 `define ENCAP_DST_MAC_HI_PORT_4_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_DST_MAC_HI_PORT_4})
 `define ENCAP_DST_MAC_LO_PORT_4_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_DST_MAC_LO_PORT_4})

 `define HARDWIRE_OUTPUT_PORTS_BASE_REG       (`UDP_BASE_ADDRESS | {`HARDWIRE_LOOKUP_BLOCK_TAG, `HARDWIRE_OUTPUT_PORTS_BASE})

 `define PRINT_USER_REG_ADDRESSES                                                                                                                   \
         $fwrite(c_reg_defines_fd, "#define ENCAP_ENABLE_PORT_1_REG                     0x%07x\n", `ENCAP_ENABLE_PORT_1_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_PORTS_PORT_1_REG                      0x%07x\n", `ENCAP_PORTS_PORT_1_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_IP_PORT_1_REG                     0x%07x\n", `ENCAP_SRC_IP_PORT_1_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_IP_PORT_1_REG                     0x%07x\n", `ENCAP_DST_IP_PORT_1_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_TTL_PROTO_PORT_1_REG                  0x%07x\n", `ENCAP_TTL_PROTO_PORT_1_REG<<2);                 \
         $fwrite(c_reg_defines_fd, "#define ENCAP_TOS_PORT_1_REG                        0x%07x\n", `ENCAP_TOS_PORT_1_REG<<2);                       \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_HI_PORT_1_REG                 0x%07x\n", `ENCAP_SRC_MAC_HI_PORT_1_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_LO_PORT_1_REG                 0x%07x\n", `ENCAP_SRC_MAC_LO_PORT_1_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_HI_PORT_1_REG                 0x%07x\n", `ENCAP_DST_MAC_HI_PORT_1_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_LO_PORT_1_REG                 0x%07x\n", `ENCAP_DST_MAC_LO_PORT_1_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_ENABLE_PORT_2_REG                     0x%07x\n", `ENCAP_ENABLE_PORT_2_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_PORTS_PORT_2_REG                      0x%07x\n", `ENCAP_PORTS_PORT_2_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_IP_PORT_2_REG                     0x%07x\n", `ENCAP_SRC_IP_PORT_2_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_IP_PORT_2_REG                     0x%07x\n", `ENCAP_DST_IP_PORT_2_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_TTL_PROTO_PORT_2_REG                  0x%07x\n", `ENCAP_TTL_PROTO_PORT_2_REG<<2);                 \
         $fwrite(c_reg_defines_fd, "#define ENCAP_TOS_PORT_2_REG                        0x%07x\n", `ENCAP_TOS_PORT_2_REG<<2);                       \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_HI_PORT_2_REG                 0x%07x\n", `ENCAP_SRC_MAC_HI_PORT_2_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_LO_PORT_2_REG                 0x%07x\n", `ENCAP_SRC_MAC_LO_PORT_2_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_HI_PORT_2_REG                 0x%07x\n", `ENCAP_DST_MAC_HI_PORT_2_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_LO_PORT_2_REG                 0x%07x\n", `ENCAP_DST_MAC_LO_PORT_2_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_LO_PORT_2_REG                 0x%07x\n", `ENCAP_DST_MAC_LO_PORT_2_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_ENABLE_PORT_3_REG                     0x%07x\n", `ENCAP_ENABLE_PORT_3_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_PORTS_PORT_3_REG                      0x%07x\n", `ENCAP_PORTS_PORT_3_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_IP_PORT_3_REG                     0x%07x\n", `ENCAP_SRC_IP_PORT_3_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_IP_PORT_3_REG                     0x%07x\n", `ENCAP_DST_IP_PORT_3_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_TTL_PROTO_PORT_3_REG                  0x%07x\n", `ENCAP_TTL_PROTO_PORT_3_REG<<2);                 \
         $fwrite(c_reg_defines_fd, "#define ENCAP_TOS_PORT_3_REG                        0x%07x\n", `ENCAP_TOS_PORT_3_REG<<2);                       \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_HI_PORT_3_REG                 0x%07x\n", `ENCAP_SRC_MAC_HI_PORT_3_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_LO_PORT_3_REG                 0x%07x\n", `ENCAP_SRC_MAC_LO_PORT_3_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_HI_PORT_3_REG                 0x%07x\n", `ENCAP_DST_MAC_HI_PORT_3_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_LO_PORT_3_REG                 0x%07x\n", `ENCAP_DST_MAC_LO_PORT_3_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_ENABLE_PORT_4_REG                     0x%07x\n", `ENCAP_ENABLE_PORT_4_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_PORTS_PORT_4_REG                      0x%07x\n", `ENCAP_PORTS_PORT_4_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_IP_PORT_4_REG                     0x%07x\n", `ENCAP_SRC_IP_PORT_4_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_IP_PORT_4_REG                     0x%07x\n", `ENCAP_DST_IP_PORT_4_REG<<2);                    \
         $fwrite(c_reg_defines_fd, "#define ENCAP_TTL_PROTO_PORT_4_REG                  0x%07x\n", `ENCAP_TTL_PROTO_PORT_4_REG<<2);                 \
         $fwrite(c_reg_defines_fd, "#define ENCAP_TOS_PORT_4_REG                        0x%07x\n", `ENCAP_TOS_PORT_4_REG<<2);                       \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_HI_PORT_4_REG                 0x%07x\n", `ENCAP_SRC_MAC_HI_PORT_4_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_LO_PORT_4_REG                 0x%07x\n", `ENCAP_SRC_MAC_LO_PORT_4_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_HI_PORT_4_REG                 0x%07x\n", `ENCAP_DST_MAC_HI_PORT_4_REG<<2);                \
         $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_LO_PORT_4_REG                 0x%07x\n", `ENCAP_DST_MAC_LO_PORT_4_REG<<2)
