/* VLAN defines */
`define VLAN_CTRL_WORD 8'h42
`define VLAN_ETHERTYPE 16'h8100

/* Other Constants */
`define ETH_TYPE_IP 16'h0800
`define IP_PROTO_TCP 8'h6
`define IP_PROTO_UDP 8'h11
`define DONT_TOUCH_SRC_PORT 16'd15

`define ENCAP_1_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
`define ENCAP_1_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
`define ENCAP_1_BLOCK_ADDR                   `ENCAP_1_BLOCK_ADDR_WIDTH'h9
`define ENCAP_1_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `ENCAP_1_BLOCK_ADDR})

`define ENCAP_2_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
`define ENCAP_2_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
`define ENCAP_2_BLOCK_ADDR                   `ENCAP_2_BLOCK_ADDR_WIDTH'hA
`define ENCAP_2_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `ENCAP_2_BLOCK_ADDR})

`define ENCAP_3_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
`define ENCAP_3_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
`define ENCAP_3_BLOCK_ADDR                   `ENCAP_3_BLOCK_ADDR_WIDTH'hB
`define ENCAP_3_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `ENCAP_3_BLOCK_ADDR})

`define ENCAP_4_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
`define ENCAP_4_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
`define ENCAP_4_BLOCK_ADDR                   `ENCAP_4_BLOCK_ADDR_WIDTH'hC
`define ENCAP_4_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `ENCAP_4_BLOCK_ADDR})

`define DECAP_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
`define DECAP_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
`define DECAP_BLOCK_ADDR                   `DECAP_BLOCK_ADDR_WIDTH'hD
`define DECAP_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `DECAP_BLOCK_ADDR})

`define ARP_REPLY_REG_ADDR_WIDTH               `UDP_BLOCK_SIZE_64_REG_ADDR_WIDTH
`define ARP_REPLY_BLOCK_ADDR_WIDTH             `UDP_BLOCK_SIZE_64_BLOCK_ADDR_WIDTH
`define ARP_REPLY_BLOCK_ADDR                   `ARP_REPLY_BLOCK_ADDR_WIDTH'hD
`define ARP_REPLY_BLOCK_TAG                    ({`UDP_BLOCK_SIZE_64_TAG, `ARP_REPLY_BLOCK_ADDR})

`define DECAP_NUM_PKTS_PROCESSED_REG             (`UDP_BASE_ADDRESS | {`DECAP_BLOCK_TAG, `DECAP_REG_ADDR_WIDTH'h0})
`define DECAP_NUM_PKTS_UNCHANGED_REG             (`UDP_BASE_ADDRESS | {`DECAP_BLOCK_TAG, `DECAP_REG_ADDR_WIDTH'h1})
`define DECAP_NUM_PKTS_DECAPPED_REG              (`UDP_BASE_ADDRESS | {`DECAP_BLOCK_TAG, `DECAP_REG_ADDR_WIDTH'h2})
`define DECAP_ENABLE_REG                         (`UDP_BASE_ADDRESS | {`DECAP_BLOCK_TAG, `DECAP_REG_ADDR_WIDTH'h3})

`define ARP_REPLY_NUM_PKTS_SENT_REG                  (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'h0})
`define ARP_REPLY_NUM_ARP_REQS_DROPPED_REG           (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'h1})
`define ARP_REPLY_NUM_ARP_REPLIES_SENT_REG           (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'h2})
`define ARP_REPLY_ENABLE_REG                         (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'h3})
`define ARP_REPLY_ETH_ADDR_PORT_0_LO_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'h4})
`define ARP_REPLY_ETH_ADDR_PORT_0_HI_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'h5})
`define ARP_REPLY_ETH_ADDR_PORT_1_LO_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'h6})
`define ARP_REPLY_ETH_ADDR_PORT_1_HI_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'h7})
`define ARP_REPLY_ETH_ADDR_PORT_2_LO_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'h8})
`define ARP_REPLY_ETH_ADDR_PORT_2_HI_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'h9})
`define ARP_REPLY_ETH_ADDR_PORT_3_LO_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'ha})
`define ARP_REPLY_ETH_ADDR_PORT_3_HI_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'hb})
`define ARP_REPLY_IP_ADDR_PORT_0_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'hc})
`define ARP_REPLY_IP_ADDR_PORT_1_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'hd})
`define ARP_REPLY_IP_ADDR_PORT_2_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'he})
`define ARP_REPLY_IP_ADDR_PORT_3_REG             (`UDP_BASE_ADDRESS | {`ARP_REPLY_BLOCK_TAG, `ARP_REPLY_REG_ADDR_WIDTH'hf})

 /* Internal register addresses */

 /*ENCAP Module */
`define ENCAP_ENABLE_PORT_1               `ENCAP_1_REG_ADDR_WIDTH'h0
`define ENCAP_PORTS_PORT_1                `ENCAP_1_REG_ADDR_WIDTH'h1

`define ENCAP_SRC_IP_PORT_1               `ENCAP_1_REG_ADDR_WIDTH'h2
`define ENCAP_DST_IP_PORT_1               `ENCAP_1_REG_ADDR_WIDTH'h3
`define ENCAP_TTL_PROTO_PORT_1            `ENCAP_1_REG_ADDR_WIDTH'h4
`define ENCAP_TOS_PORT_1                  `ENCAP_1_REG_ADDR_WIDTH'h5
`define ENCAP_SRC_MAC_HI_PORT_1           `ENCAP_1_REG_ADDR_WIDTH'h6
`define ENCAP_SRC_MAC_LO_PORT_1           `ENCAP_1_REG_ADDR_WIDTH'h7
`define ENCAP_DST_MAC_HI_PORT_1           `ENCAP_1_REG_ADDR_WIDTH'h8
`define ENCAP_DST_MAC_LO_PORT_1           `ENCAP_1_REG_ADDR_WIDTH'h9

`define ENCAP_ENABLE_PORT_2               `ENCAP_2_REG_ADDR_WIDTH'h0
`define ENCAP_PORTS_PORT_2                `ENCAP_2_REG_ADDR_WIDTH'h1

`define ENCAP_SRC_IP_PORT_2               `ENCAP_2_REG_ADDR_WIDTH'h2
`define ENCAP_DST_IP_PORT_2               `ENCAP_2_REG_ADDR_WIDTH'h3
`define ENCAP_TTL_PROTO_PORT_2            `ENCAP_2_REG_ADDR_WIDTH'h4
`define ENCAP_TOS_PORT_2                  `ENCAP_2_REG_ADDR_WIDTH'h5
`define ENCAP_SRC_MAC_HI_PORT_2           `ENCAP_2_REG_ADDR_WIDTH'h6
`define ENCAP_SRC_MAC_LO_PORT_2           `ENCAP_2_REG_ADDR_WIDTH'h7
`define ENCAP_DST_MAC_HI_PORT_2           `ENCAP_2_REG_ADDR_WIDTH'h8
`define ENCAP_DST_MAC_LO_PORT_2           `ENCAP_2_REG_ADDR_WIDTH'h9

`define ENCAP_ENABLE_PORT_3               `ENCAP_3_REG_ADDR_WIDTH'h0
`define ENCAP_PORTS_PORT_3                `ENCAP_3_REG_ADDR_WIDTH'h1

`define ENCAP_SRC_IP_PORT_3               `ENCAP_3_REG_ADDR_WIDTH'h2
`define ENCAP_DST_IP_PORT_3               `ENCAP_3_REG_ADDR_WIDTH'h3
`define ENCAP_TTL_PROTO_PORT_3            `ENCAP_3_REG_ADDR_WIDTH'h4
`define ENCAP_TOS_PORT_3                  `ENCAP_3_REG_ADDR_WIDTH'h5
`define ENCAP_SRC_MAC_HI_PORT_3           `ENCAP_3_REG_ADDR_WIDTH'h6
`define ENCAP_SRC_MAC_LO_PORT_3           `ENCAP_3_REG_ADDR_WIDTH'h7
`define ENCAP_DST_MAC_HI_PORT_3           `ENCAP_3_REG_ADDR_WIDTH'h8
`define ENCAP_DST_MAC_LO_PORT_3           `ENCAP_3_REG_ADDR_WIDTH'h9

`define ENCAP_ENABLE_PORT_4               `ENCAP_4_REG_ADDR_WIDTH'h0
`define ENCAP_PORTS_PORT_4                `ENCAP_4_REG_ADDR_WIDTH'h1

`define ENCAP_SRC_IP_PORT_4               `ENCAP_4_REG_ADDR_WIDTH'h2
`define ENCAP_DST_IP_PORT_4               `ENCAP_4_REG_ADDR_WIDTH'h3
`define ENCAP_TTL_PROTO_PORT_4            `ENCAP_4_REG_ADDR_WIDTH'h4
`define ENCAP_TOS_PORT_4                  `ENCAP_4_REG_ADDR_WIDTH'h5
`define ENCAP_SRC_MAC_HI_PORT_4           `ENCAP_4_REG_ADDR_WIDTH'h6
`define ENCAP_SRC_MAC_LO_PORT_4           `ENCAP_4_REG_ADDR_WIDTH'h7
`define ENCAP_DST_MAC_HI_PORT_4           `ENCAP_4_REG_ADDR_WIDTH'h8
`define ENCAP_DST_MAC_LO_PORT_4           `ENCAP_4_REG_ADDR_WIDTH'h9

 // ENCAP
`define ENCAP_ENABLE_PORT_1_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_ENABLE_PORT_1})
`define ENCAP_PORTS_PORT_1_REG             (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_PORTS_PORT_1})

`define ENCAP_SRC_IP_PORT_1_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_SRC_IP_PORT_1})
`define ENCAP_DST_IP_PORT_1_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_DST_IP_PORT_1})
`define ENCAP_TTL_PROTO_PORT_1_REG         (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_TTL_PROTO_PORT_1})
`define ENCAP_TOS_PORT_1_REG               (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_TOS_PORT_1})
`define ENCAP_SRC_MAC_HI_PORT_1_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_SRC_MAC_HI_PORT_1})
`define ENCAP_SRC_MAC_LO_PORT_1_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_SRC_MAC_LO_PORT_1})
`define ENCAP_DST_MAC_HI_PORT_1_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_DST_MAC_HI_PORT_1})
`define ENCAP_DST_MAC_LO_PORT_1_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_1_BLOCK_TAG, `ENCAP_DST_MAC_LO_PORT_1})

`define ENCAP_ENABLE_PORT_2_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_ENABLE_PORT_2})
`define ENCAP_PORTS_PORT_2_REG             (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_PORTS_PORT_2})

`define ENCAP_SRC_IP_PORT_2_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_SRC_IP_PORT_2})
`define ENCAP_DST_IP_PORT_2_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_DST_IP_PORT_2})
`define ENCAP_TTL_PROTO_PORT_2_REG         (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_TTL_PROTO_PORT_2})
`define ENCAP_TOS_PORT_2_REG               (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_TOS_PORT_2})
`define ENCAP_SRC_MAC_HI_PORT_2_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_SRC_MAC_HI_PORT_2})
`define ENCAP_SRC_MAC_LO_PORT_2_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_SRC_MAC_LO_PORT_2})
`define ENCAP_DST_MAC_HI_PORT_2_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_DST_MAC_HI_PORT_2})
`define ENCAP_DST_MAC_LO_PORT_2_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_2_BLOCK_TAG, `ENCAP_DST_MAC_LO_PORT_2})

`define ENCAP_ENABLE_PORT_3_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_ENABLE_PORT_3})
`define ENCAP_PORTS_PORT_3_REG             (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_PORTS_PORT_3})

`define ENCAP_SRC_IP_PORT_3_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_SRC_IP_PORT_3})
`define ENCAP_DST_IP_PORT_3_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_DST_IP_PORT_3})
`define ENCAP_TTL_PROTO_PORT_3_REG         (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_TTL_PROTO_PORT_3})
`define ENCAP_TOS_PORT_3_REG               (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_TOS_PORT_3})
`define ENCAP_SRC_MAC_HI_PORT_3_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_SRC_MAC_HI_PORT_3})
`define ENCAP_SRC_MAC_LO_PORT_3_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_SRC_MAC_LO_PORT_3})
`define ENCAP_DST_MAC_HI_PORT_3_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_DST_MAC_HI_PORT_3})
`define ENCAP_DST_MAC_LO_PORT_3_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_3_BLOCK_TAG, `ENCAP_DST_MAC_LO_PORT_3})

`define ENCAP_ENABLE_PORT_4_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_ENABLE_PORT_4})
`define ENCAP_PORTS_PORT_4_REG             (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_PORTS_PORT_4})

`define ENCAP_SRC_IP_PORT_4_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_SRC_IP_PORT_4})
`define ENCAP_DST_IP_PORT_4_REG            (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_DST_IP_PORT_4})
`define ENCAP_TTL_PROTO_PORT_4_REG         (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_TTL_PROTO_PORT_4})
`define ENCAP_TOS_PORT_4_REG               (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_TOS_PORT_4})
`define ENCAP_SRC_MAC_HI_PORT_4_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_SRC_MAC_HI_PORT_4})
`define ENCAP_SRC_MAC_LO_PORT_4_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_SRC_MAC_LO_PORT_4})
`define ENCAP_DST_MAC_HI_PORT_4_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_DST_MAC_HI_PORT_4})
`define ENCAP_DST_MAC_LO_PORT_4_REG        (`UDP_BASE_ADDRESS  | {`ENCAP_4_BLOCK_TAG, `ENCAP_DST_MAC_LO_PORT_4})

`define PRINT_USER_REG_ADDRESSES                                                                                                                   \
 $fwrite(c_reg_defines_fd, "#define ARP_REPLY_NUM_PKTS_SENT_REG                    0x%07x\n", `ARP_REPLY_NUM_PKTS_SENT_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_NUM_ARP_REQS_DROPPED_REG             0x%07x\n", `ARP_REPLY_NUM_ARP_REQS_DROPPED_REG<<2);            \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_NUM_ARP_REPLIES_SENT_REG             0x%07x\n", `ARP_REPLY_NUM_ARP_REPLIES_SENT_REG<<2);            \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_ENABLE_REG                           0x%07x\n", `ARP_REPLY_ENABLE_REG<<2);                          \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_ETH_ADDR_PORT_0_LO_REG               0x%07x\n", `ARP_REPLY_ETH_ADDR_PORT_0_LO_REG<<2);              \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_ETH_ADDR_PORT_0_HI_REG               0x%07x\n", `ARP_REPLY_ETH_ADDR_PORT_0_HI_REG<<2);              \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_ETH_ADDR_PORT_1_LO_REG               0x%07x\n", `ARP_REPLY_ETH_ADDR_PORT_1_LO_REG<<2);              \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_ETH_ADDR_PORT_1_HI_REG               0x%07x\n", `ARP_REPLY_ETH_ADDR_PORT_1_HI_REG<<2);              \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_ETH_ADDR_PORT_2_LO_REG               0x%07x\n", `ARP_REPLY_ETH_ADDR_PORT_2_LO_REG<<2);              \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_ETH_ADDR_PORT_2_HI_REG               0x%07x\n", `ARP_REPLY_ETH_ADDR_PORT_2_HI_REG<<2);              \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_ETH_ADDR_PORT_3_LO_REG               0x%07x\n", `ARP_REPLY_ETH_ADDR_PORT_3_LO_REG<<2);              \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_ETH_ADDR_PORT_3_HI_REG               0x%07x\n", `ARP_REPLY_ETH_ADDR_PORT_3_HI_REG<<2);              \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_IP_ADDR_PORT_0_REG                   0x%07x\n", `ARP_REPLY_IP_ADDR_PORT_0_REG<<2);                  \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_IP_ADDR_PORT_1_REG                   0x%07x\n", `ARP_REPLY_IP_ADDR_PORT_1_REG<<2);                  \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_IP_ADDR_PORT_2_REG                   0x%07x\n", `ARP_REPLY_IP_ADDR_PORT_2_REG<<2);                  \
  $fwrite(c_reg_defines_fd, "#define ARP_REPLY_IP_ADDR_PORT_3_REG                   0x%07x\n\n", `ARP_REPLY_IP_ADDR_PORT_3_REG<<2);                \
                                                                                                                                                   \
  $fwrite(c_reg_defines_fd, "#define DECAP_NUM_PKTS_PROCESSED_REG                   0x%07x\n", `DECAP_NUM_PKTS_PROCESSED_REG<<2);                  \
  $fwrite(c_reg_defines_fd, "#define DECAP_NUM_PKTS_UNCHANGED_REG                   0x%07x\n", `DECAP_NUM_PKTS_UNCHANGED_REG<<2);                  \
  $fwrite(c_reg_defines_fd, "#define DECAP_NUM_PKTS_DECAPPED_REG                    0x%07x\n", `DECAP_NUM_PKTS_DECAPPED_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define DECAP_ENABLE_REG                               0x%07x\n\n", `DECAP_ENABLE_REG<<2);                            \
                                                                                                                                                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_ENABLE_PORT_1_REG                        0x%07x\n", `ENCAP_ENABLE_PORT_1_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_PORTS_PORT_1_REG                         0x%07x\n", `ENCAP_PORTS_PORT_1_REG<<2);                        \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_IP_PORT_1_REG                        0x%07x\n", `ENCAP_SRC_IP_PORT_1_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_IP_PORT_1_REG                        0x%07x\n", `ENCAP_DST_IP_PORT_1_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_TTL_PROTO_PORT_1_REG                     0x%07x\n", `ENCAP_TTL_PROTO_PORT_1_REG<<2);                    \
  $fwrite(c_reg_defines_fd, "#define ENCAP_TOS_PORT_1_REG                           0x%07x\n", `ENCAP_TOS_PORT_1_REG<<2);                          \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_HI_PORT_1_REG                    0x%07x\n", `ENCAP_SRC_MAC_HI_PORT_1_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_LO_PORT_1_REG                    0x%07x\n", `ENCAP_SRC_MAC_LO_PORT_1_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_HI_PORT_1_REG                    0x%07x\n", `ENCAP_DST_MAC_HI_PORT_1_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_LO_PORT_1_REG                    0x%07x\n", `ENCAP_DST_MAC_LO_PORT_1_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_ENABLE_PORT_2_REG                        0x%07x\n", `ENCAP_ENABLE_PORT_2_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_PORTS_PORT_2_REG                         0x%07x\n", `ENCAP_PORTS_PORT_2_REG<<2);                        \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_IP_PORT_2_REG                        0x%07x\n", `ENCAP_SRC_IP_PORT_2_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_IP_PORT_2_REG                        0x%07x\n", `ENCAP_DST_IP_PORT_2_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_TTL_PROTO_PORT_2_REG                     0x%07x\n", `ENCAP_TTL_PROTO_PORT_2_REG<<2);                    \
  $fwrite(c_reg_defines_fd, "#define ENCAP_TOS_PORT_2_REG                           0x%07x\n", `ENCAP_TOS_PORT_2_REG<<2);                          \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_HI_PORT_2_REG                    0x%07x\n", `ENCAP_SRC_MAC_HI_PORT_2_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_LO_PORT_2_REG                    0x%07x\n", `ENCAP_SRC_MAC_LO_PORT_2_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_HI_PORT_2_REG                    0x%07x\n", `ENCAP_DST_MAC_HI_PORT_2_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_LO_PORT_2_REG                    0x%07x\n", `ENCAP_DST_MAC_LO_PORT_2_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_LO_PORT_2_REG                    0x%07x\n", `ENCAP_DST_MAC_LO_PORT_2_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_ENABLE_PORT_3_REG                        0x%07x\n", `ENCAP_ENABLE_PORT_3_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_PORTS_PORT_3_REG                         0x%07x\n", `ENCAP_PORTS_PORT_3_REG<<2);                        \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_IP_PORT_3_REG                        0x%07x\n", `ENCAP_SRC_IP_PORT_3_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_IP_PORT_3_REG                        0x%07x\n", `ENCAP_DST_IP_PORT_3_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_TTL_PROTO_PORT_3_REG                     0x%07x\n", `ENCAP_TTL_PROTO_PORT_3_REG<<2);                    \
  $fwrite(c_reg_defines_fd, "#define ENCAP_TOS_PORT_3_REG                           0x%07x\n", `ENCAP_TOS_PORT_3_REG<<2);                          \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_HI_PORT_3_REG                    0x%07x\n", `ENCAP_SRC_MAC_HI_PORT_3_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_LO_PORT_3_REG                    0x%07x\n", `ENCAP_SRC_MAC_LO_PORT_3_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_HI_PORT_3_REG                    0x%07x\n", `ENCAP_DST_MAC_HI_PORT_3_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_LO_PORT_3_REG                    0x%07x\n", `ENCAP_DST_MAC_LO_PORT_3_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_ENABLE_PORT_4_REG                        0x%07x\n", `ENCAP_ENABLE_PORT_4_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_PORTS_PORT_4_REG                         0x%07x\n", `ENCAP_PORTS_PORT_4_REG<<2);                        \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_IP_PORT_4_REG                        0x%07x\n", `ENCAP_SRC_IP_PORT_4_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_IP_PORT_4_REG                        0x%07x\n", `ENCAP_DST_IP_PORT_4_REG<<2);                       \
  $fwrite(c_reg_defines_fd, "#define ENCAP_TTL_PROTO_PORT_4_REG                     0x%07x\n", `ENCAP_TTL_PROTO_PORT_4_REG<<2);                    \
  $fwrite(c_reg_defines_fd, "#define ENCAP_TOS_PORT_4_REG                           0x%07x\n", `ENCAP_TOS_PORT_4_REG<<2);                          \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_HI_PORT_4_REG                    0x%07x\n", `ENCAP_SRC_MAC_HI_PORT_4_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_SRC_MAC_LO_PORT_4_REG                    0x%07x\n", `ENCAP_SRC_MAC_LO_PORT_4_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_HI_PORT_4_REG                    0x%07x\n", `ENCAP_DST_MAC_HI_PORT_4_REG<<2);                   \
  $fwrite(c_reg_defines_fd, "#define ENCAP_DST_MAC_LO_PORT_4_REG                    0x%07x\n", `ENCAP_DST_MAC_LO_PORT_4_REG<<2)
