typedef opaque realm_id[20];
/* This is a CapabilityMac. RPC clients and servers will need to cast
   the xdr_capmac* to a CapabilityMac*.
 */
typedef opaque xdr_capmac<>; 

enum icingps_stat {
   ICINGPS_OK = 0,
   ICINGPS_NOTOK = 1,
   ICINGPS_NOTFOUND = 2
};

struct waypoint_info {
    realm_id waypoint_id;
    string   waypoint_name<>;  /* dotted-four IP or DNS name */
    uint32_t waypoint_udp_port; /* network byte order */
};

struct precord_ent {
    waypoint_info waypoint;
    xdr_capmac path_from_waypoint<>;
    unsigned metric;
};

struct precord {
    realm_id dest;
    precord_ent entries<>;
};

union icingps_get_res switch(icingps_stat status) {
    case ICINGPS_OK:
	precord prec;
    case ICINGPS_NOTOK:
	void;
    default:
	void;
};

struct icingps_get_arg {
    string name<255>;
};

struct icingps_set_arg {
    string name<255>;
    precord prec;
};

program ICINGPS_PROGRAM {
    version ICINGPS_VERSION {

	void
	ICINGPS_PROC_NULL (void) = 1;

	icingps_get_res
	ICINGPS_PROC_GET (icingps_get_arg) = 2;

	icingps_stat
	ICINGPS_PROC_SET (icingps_set_arg) = 3;

    } = 1;

} = 9812313;
