#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>

#define PERROR(x) {perror(x); exit(1); }

int main()
{
	const char *alpha = "abcdefghijklmnopqrstuvwxyz";
	int fd = socket(AF_INET, SOCK_DGRAM, 0);
	if(fd == -1)
		PERROR("socket");

	sockaddr_in sin;
	bzero(&sin, sizeof(sin));
	sin.sin_family = AF_INET;
	sin.sin_port = htons(7662);
	//sin.sin_addr.s_addr = inet_addr("128.83.141.57");
	sin.sin_addr.s_addr = inet_addr("192.168.39.5");

	if(bind(fd, (sockaddr *)&sin, sizeof(sin)) < 0)
		PERROR("bind");

	sin.sin_port = htons(4602);
	sin.sin_addr.s_addr = inet_addr("64.57.23.74");

	while(1)
	{
		char buf[2048];
		int sent, recvd;
		sockaddr_in peer_sin;
		socklen_t peer_sin_len;
		bzero(buf, sizeof(buf));
		bzero(&peer_sin, sizeof(peer_sin));

		if((sent = sendto(fd, alpha, 26, 0, (sockaddr *)&sin, sizeof(sin))) < 26 )
				PERROR("send");

		if((recvd = recvfrom(fd, buf, sizeof(buf), 0, (sockaddr *)&peer_sin, &peer_sin_len)) < 0)
			perror("bad recvfrom");
		else
		{
			printf("Received %d bytes: %s\n", recvd, buf);
			printf("\tfrom %s:%d\n", inet_ntoa(peer_sin.sin_addr), ntohs(peer_sin.sin_port));
		}
	}
	return 0;
}
