#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>

#define PERROR(x) {perror(x); exit(1); }

int main(int argc, char** argv)
{
    sockaddr_in sin;

    int s = socket(AF_INET, SOCK_DGRAM, 0);
    if (s == -1)
	PERROR("socket");

    memset(&sin, 0, sizeof(sockaddr_in));
    sin.sin_family = AF_INET;
    sin.sin_port = htons(0x2345);
    sin.sin_addr.s_addr = inet_addr("192.168.39.1");

    if (bind(s, (sockaddr*)&sin, sizeof(sin)) < 0)
	PERROR("bind");

#if 0
    struct ifreq ifr;
    memset(&ifr, 0, sizeof(ifr));
    strncpy(ifr.ifr_name, "tun0", sizeof(ifr.ifr_name));
    if (ioctl(s, SIOCGIFFLAGS, &ifr) != 0)
        perror("ioctl"); 

    ifr.ifr_flags |= IFF_PROMISC;

    if (ioctl(s, SIOCSIFFLAGS, &ifr) <0)
	perror("ioctl");
#endif

    while (1) {

	char buf[2048];
	int rc;
	sockaddr_in peer_sin;
	socklen_t peer_sin_len;

	memset(buf, 0, sizeof(buf));
	memset(&peer_sin, 0, sizeof(peer_sin));
	
	if ( (rc = recvfrom(s, buf, sizeof(buf), 0,
		       (sockaddr*)&peer_sin, &peer_sin_len)) < 0) 
	    perror("unhappy recvfrom");
	else {
	    printf("Received %d bytes: %s\n", rc, buf);
	    printf("  from %s:%d\n", inet_ntoa(peer_sin.sin_addr),
		   ntohs(peer_sin.sin_port));	
	}
    }

    return 0;
}
