 `define COUNTER_BLOCK_ADDR_WIDTH         `BLOCK_SIZE_64k_BLOCK_ADDR_WIDTH
 `define COUNTER_REG_ADDR_WIDTH           `BLOCK_SIZE_64k_REG_ADDR_WIDTH
 `define COUNTER_BLOCK_ADDR               `COUNTER_BLOCK_ADDR_WIDTH'h4

 `define COUNTER_1_REG                   `COUNTER_REG_ADDR_WIDTH'h0
 `define COUNTER_2_REG                   `COUNTER_REG_ADDR_WIDTH'h1
 `define COUNTER_3_REG                   `COUNTER_REG_ADDR_WIDTH'h2
 `define COUNTER_4_REG                   `COUNTER_REG_ADDR_WIDTH'h3

 `define COUNTER_1_2_REG_LOAD            `COUNTER_REG_ADDR_WIDTH'h4
 `define COUNTER_3_4_REG_LOAD            `COUNTER_REG_ADDR_WIDTH'h5

 `define COUNTER_BIT_95_64                `COUNTER_REG_ADDR_WIDTH'h6
 `define COUNTER_BIT_63_32                `COUNTER_REG_ADDR_WIDTH'h7
 `define COUNTER_BIT_31_0                 `COUNTER_REG_ADDR_WIDTH'h8
 `define COUNTER_READ_ENABLE              `COUNTER_REG_ADDR_WIDTH'h9

 `define CLK_SYN_0_COUNTER_RESET           `COUNTER_REG_ADDR_WIDTH'ha
 `define CLK_SYN_0_TX_LO                   `COUNTER_REG_ADDR_WIDTH'hb
 `define CLK_SYN_0_TX_HI                   `COUNTER_REG_ADDR_WIDTH'hc
 `define CLK_SYN_0_RX_LO                   `COUNTER_REG_ADDR_WIDTH'hd
 `define CLK_SYN_0_RX_HI                   `COUNTER_REG_ADDR_WIDTH'he

 `define CLK_SYN_1_COUNTER_RESET           `COUNTER_REG_ADDR_WIDTH'hf
 `define CLK_SYN_1_TX_LO                   `COUNTER_REG_ADDR_WIDTH'h10
 `define CLK_SYN_1_TX_HI                   `COUNTER_REG_ADDR_WIDTH'h11
 `define CLK_SYN_1_RX_LO                   `COUNTER_REG_ADDR_WIDTH'h12
 `define CLK_SYN_1_RX_HI                   `COUNTER_REG_ADDR_WIDTH'h13

 `define CLK_SYN_2_COUNTER_RESET           `COUNTER_REG_ADDR_WIDTH'h14
 `define CLK_SYN_2_TX_LO                   `COUNTER_REG_ADDR_WIDTH'h15
 `define CLK_SYN_2_TX_HI                   `COUNTER_REG_ADDR_WIDTH'h16
 `define CLK_SYN_2_RX_LO                   `COUNTER_REG_ADDR_WIDTH'h17
 `define CLK_SYN_2_RX_HI                   `COUNTER_REG_ADDR_WIDTH'h18

 `define CLK_SYN_3_COUNTER_RESET           `COUNTER_REG_ADDR_WIDTH'h19
 `define CLK_SYN_3_TX_LO                   `COUNTER_REG_ADDR_WIDTH'h1a
 `define CLK_SYN_3_TX_HI                   `COUNTER_REG_ADDR_WIDTH'h1b
 `define CLK_SYN_3_RX_LO                   `COUNTER_REG_ADDR_WIDTH'h1c
 `define CLK_SYN_3_RX_HI                   `COUNTER_REG_ADDR_WIDTH'h1d

 `define PTP_VALID_RX                      `COUNTER_REG_ADDR_WIDTH'h1e
 `define PTP_VALID_TX                      `COUNTER_REG_ADDR_WIDTH'h1f
 `define PTP_ENABLE_MASK_RX                `COUNTER_REG_ADDR_WIDTH'h20
 `define PTP_ENABLE_MASK_TX                `COUNTER_REG_ADDR_WIDTH'H21
 `define PTP_MASK_RX                       `COUNTER_REG_ADDR_WIDTH'h22
 `define PTP_MASK_TX                       `COUNTER_REG_ADDR_WIDTH'h23

`define PRINT_USER_REG_ADDRESSES                                                                                                                  \
         $fwrite(c_reg_defines_fd, "#define STAMP_COUNTER_1_REG                                  0x%07x\n",  `STAMP_COUNTER_1_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define STAMP_COUNTER_2_REG                                  0x%07x\n",  `STAMP_COUNTER_2_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define STAMP_COUNTER_3_REG                                  0x%07x\n",  `STAMP_COUNTER_3_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define STAMP_COUNTER_4_REG                                  0x%07x\n",  `STAMP_COUNTER_4_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define STAMP_COUNTER_1_2_REG_LOAD                           0x%07x\n",  `STAMP_COUNTER_1_2_REG_LOAD<<2);                         \
         $fwrite(c_reg_defines_fd, "#define STAMP_COUNTER_3_4_REG_LOAD                           0x%07x\n\n",  `STAMP_COUNTER_3_4_REG_LOAD<<2);                       \
         $fwrite(c_reg_defines_fd, "#define STAMP_COUNTER_READ_ENABLE                            0x%07x\n\n",  `STAMP_COUNTER_READ_ENABLE<<2);                        \
         $fwrite(c_reg_defines_fd, "#define STAMP_COUNTER_BIT_95_64                              0x%07x\n\n",  `STAMP_COUNTER_BIT_95_64<<2);                          \
         $fwrite(c_reg_defines_fd, "#define STAMP_COUNTER_BIT_63_32                              0x%07x\n\n",  `STAMP_COUNTER_BIT_63_32<<2);                          \
         $fwrite(c_reg_defines_fd, "#define STAMP_COUNTER_BIT_31_0                               0x%07x\n\n",  `STAMP_COUNTER_BIT_31_0<<2);                           \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_0_COUNTER_RESET                              0x%07x\n",  `CLK_SYN_0_COUNTER_RESET_REG<<2);                        \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_0_TX_LO_REG                                  0x%07x\n",  `CLK_SYN_0_TX_LO_REG<<2) ;                               \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_0_TX_HI_REG                                  0x%07x\n",  `CLK_SYN_0_TX_HI_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_0_RX_LO_REG                                  0x%07x\n",  `CLK_SYN_0_RX_LO_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_0_RX_HI_REG                                  0x%07x\n",  `CLK_SYN_0_RX_HI_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_1_COUNTER_RESET                              0x%07x\n",  `CLK_SYN_1_COUNTER_RESET_REG<<2);                        \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_1_TX_LO_REG                                  0x%07x\n",  `CLK_SYN_1_TX_LO_REG<<2) ;                               \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_1_TX_HI_REG                                  0x%07x\n",  `CLK_SYN_1_TX_HI_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_1_RX_LO_REG                                  0x%07x\n",  `CLK_SYN_1_RX_LO_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_1_RX_HI_REG                                  0x%07x\n",  `CLK_SYN_1_RX_HI_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_2_COUNTER_RESET                              0x%07x\n",  `CLK_SYN_2_COUNTER_RESET_REG<<2);                        \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_2_TX_LO_REG                                  0x%07x\n",  `CLK_SYN_2_TX_LO_REG<<2) ;                               \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_2_TX_HI_REG                                  0x%07x\n",  `CLK_SYN_2_TX_HI_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_2_RX_LO_REG                                  0x%07x\n",  `CLK_SYN_2_RX_LO_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_2_RX_HI_REG                                  0x%07x\n",  `CLK_SYN_2_RX_HI_REG<<2);                                \
                                                                                                                                                                      \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_3_COUNTER_RESET                              0x%07x\n",  `CLK_SYN_3_COUNTER_RESET_REG<<2);                        \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_3_TX_LO_REG                                  0x%07x\n",  `CLK_SYN_3_TX_LO_REG<<2) ;                               \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_3_TX_HI_REG                                  0x%07x\n",  `CLK_SYN_3_TX_HI_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_3_RX_LO_REG                                  0x%07x\n",  `CLK_SYN_3_RX_LO_REG<<2);                                \
         $fwrite(c_reg_defines_fd, "#define CLK_SYN_3_RX_HI_REG                                  0x%07x\n",  `CLK_SYN_3_RX_HI_REG <<2);                               \
         $fwrite(c_reg_defines_fd, "#define PTP_VALID_RX_REG                                     0x%07x\n",  `PTP_VALID_RX_REG<<2) ;                                  \
         $fwrite(c_reg_defines_fd, "#define PTP_VALID_TX_REG                                     0x%07x\n",  `PTP_VALID_TX_REG<<2) ;                                  \
         $fwrite(c_reg_defines_fd, "#define PTP_ENABLE_MASK_RX_REG                               0x%07x\n",  `PTP_ENABLE_MASK_RX_REG<<2) ;                            \
         $fwrite(c_reg_defines_fd, "#define PTP_ENABLE_MASK_TX_REG                               0x%07x\n",  `PTP_ENABLE_MASK_TX_REG<<2) ;                            \
         $fwrite(c_reg_defines_fd, "#define PTP_MASK_RX_REG                                      0x%07x\n",  `PTP_MASK_RX_REG<<2) ;                                   \
         $fwrite(c_reg_defines_fd, "#define PTP_MASK_TX_REG                                      0x%07x\n",  `PTP_MASK_TX_REG<<2)
