#include "async.h"
#include "arpc.h"
#include "crypt.h"
#include "ecdh.h"
#include <cstring>
#include <cstdio>

char *dir;

void writekey(int32_t num)
{
	char filename[256];
	char cur[2];
	cur[1] ='\0';
	cur[0] = 97 + num;

	strncpy(filename, dir, 256);
	strcat(filename, "/");
	strcat(filename, cur);

	FILE *keyfile = fopen(filename, "w");
	if(!keyfile)
		fatal("Could not open file %s for writing.\nerrno: %d - %m\n", filename, errno);

	ecdh_priv pk;

	chopped_ecpk_raw pubraw;
	pk.to_chopped_ecpk_raw(pubraw);
	fputs("id\t", keyfile);
	uint8_t *raw = (uint8_t *)pubraw;
	for(uint32_t i = 0; i < 20; i++)
		fprintf(keyfile, "%02X", raw[i] & 0xFF);
	fputs("\npr\t", keyfile);

	const bigint &x = pk.getraw();
	for(uint32_t i = 0; i < x.getraw().len(); i++)
		fprintf(keyfile, "%02X", x.getraw().cstr()[i] & 0xFF);
	fputs("\n", keyfile);

}

int main(int32_t argc, char **argv)
{
	if(argc < 3)
	{
		warn << "Usage: keygen <path to keys> <number of keys>\n";
		return 1;
	}

	int32_t numkeys = atoi(argv[2]);
	dir = argv[1];

	for(int i = 0; i < numkeys; i++)
		writekey(i);

	return 0;
}
